/***************************************************************************
 *   Copyright (C) 2010 by vs   *
 *   vlados@armpvsltvm.king.ec.gc.ca   *
  ***************************************************************************/
/* SERACQ1.C serial acquisition 12 April 2007/01 Aug 2007/jws
 * acquires serial data from a hotplate, parsivel, poss & FD12P and writes it to disk files
//=========================================================================================================================

July 27, 2010 sb -removed all HOTPLATE references for simplification.
July 26, 2010 vs -modify read par function: does not read paresivel/vis/pwd related flags (precent, sendmail, comport). 
                  Instead, those flags are set at beggining of code to 0 - not present. This version requires 
                  modified version of POSACQ.PAR file - reduced for bove mentioned field.
July 26, 2010 vs -removed dailyplots()
July 26, 2010 vs -removed sumlog file references            
//---------------------------------------------------------- VER 1.5 up --------------------------------------------
//July 26, 2010 vs - Introduced path in parameter file. This is done to avoid compiling and recoding software 
                     for different computers. Now software needs to be started specifiyng path/name of PAR file
                     (example possaqc POSAQ1.PAR)     
//---------------------------------------------------------- VER 1.4 up --------------------------------------------
//June 24, 2010 vs - in FaultMail -Tail to last 2 lines of MessageFile
//June 24, 2010 vs - in ExtractKeyboard() - introduce software version comand - "ver"
//June 24, 2010 vs - Introduced PAR FIle related error counters
//---------------------------------------------------------- VER 1.3 up --------------------------------------------

//June 18, 2010 vs - Fix in testday() function - call CreateLogDate() function - to create new filenames
//June 18, 2010 vs - Change MailFault() - recognize which device generate minute fault
//June 14, 2010 vs - Implement Aux Device support(Also changed Par File)
//June 03, 2010 vs - Check Hot issue
//June 03, 2010 vs -Created MessageFile - Main Log file 

VS - delete curtime() and use Timing instead
//=========================================================================================================================
01 Aug 08 - fixed bug in poss accum after false alarm/jws
	    -added delay in vis output commands/jws
15 Jun 07 - fixed vis \ to / /jws
12 Jun 07 - separate plotcmd files/jws
07 Jun 07 - added parsivel raw 32x32 array file/jws
07 Jun 07 - added vis change \\\ to -99/jws
	    -added separate par, poss and vis daily plots/jws
06 Jun 07 - changed vis sensor from an FD12P to a PWD22/jws
06 Jun 07 - hotplate removed/jws
24 May 07 - added Steve's parsivel output set(checkparsivelsb())/jws
23 May 07 - added vis time routine/jws
	    ignore 0x07 (bell) in vis data /jws
18 May 07 - zero pos rr during false alarm fault/jws
17 May 07 - selected subset of pos faults for emails/jws
16 May 07 - added parsivel reset command/jws
            added vis reset command
	    added daily pos accumulation
	    cleaned up time acquisition
14 May 07 - fixed vis char count/jws
03 May 07 - added visibility FD12P sensor/jws
30 Apr 07 - fixed date in plot title/jws
27 Apr 07 - added summary daily plot/jws
26 Apr 07 - added hot plate daily plot/jws
24 Apr 07 - added current rate and accm SUMmary file/jws
23 Apr 07 - added poss error codes/jws
20 Apr 07 - seracq1 from seracq0/jws
	    changed all references from seracq0 to seracq1
19 Apr 07 - added SERACQ0.PAR parameter file/jws
18 Apr 07 - adding poss code/jws
18 Apr 07 - adding parsivel code/jws
18 Apr 07 - hotplate code works pretty well/jws

 * regulus /home/posacq/posacq
 * poss on ttyUSB2
 * compile with  <gcc -o seracq1 seracq1.c>
*/

#include <sys/timeb.h>
#include <stdio.h>
#include <time.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <termios.h>
#include <stdio.h>

#include <curses.h>
#include <fcntl.h>
#include <fcntl.h>
#include <malloc.h>
#include <memory.h>
#include <unistd.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <term.h>

//#define _POSIX_SOURCE 1

#define DEBUG 0

char VERDATE[] = "POSACQ1-V1.6 July 27 2010";  // change this each edit 

char mainpath[60]="";

char parpath[50]="";//"/home/vlados/operator/data/";
char possaccfile[60] ="";// "/home/vlados/operator/posaccmsod.txt";
char TempMailFile[60] = "";//"/home/vlados/operator/lastmailmes";
char InParFileName[60] = "";//"/home/vlados/operator/POSACQ1.PAR";

/*
#if (DEBUG == 1)
char parpath[30]="/home/vlados/operator/data/";
char possaccfile[36] = "/home/vlados/operator/posaccmsod.txt";
char TempMailFile[] = "/home/vlados/operator/lastmailmes";
char InParFileName[] = "/home/vlados/operator/POSACQ1.PAR";
#else
char parpath[30]="/home/posacq/posacq/data/";
char possaccfile[50] = "/home/posacq/posacq/posaccmsod.txt";
char TempMailFile[] = "/home/posacq/posacq/lastmailmes";
char InParFileName[] = "/home/posacq/posacq/POSACQ1.PAR";
#endif
*/
//	if((fppar = fopen("/home/posacq/posacq/POSACQ1.PAR","rt")) == NULL)

char plotdate[11]="yyyy/mm/dd";			// date for plot title 
char scurdatetim[21]="30/01/2007,13:59:59,";	// current date time string

char vispngfile[16];//="visyyyymmdd.png";	// daily vis png plot 
char vispnglog[80];

char auxlogfile[16];
char MessageFile[80];
char parfile[16];
char parlog[80];
char parrawfile[19];	// 32x32 array of raw data 
char parrawlog[80];
char poslog[80];
char vislog[80];
//char sumlog[80];
char mesparlog[80];
char mesposlog[80];
char mesvislog[80];
char parpnglog[80];
char pospnglog[80];
char sumpnglog[80];

unsigned int nloops=0;	// how many times through main loop in 1 min 
char syscmd[256];
char string[256]={0};	// a general string variable 

char RxParsivel[4500]={0};           //char sparsivel[4500]={0};	// one line of data 
float parrate=-99.;		// current parsivel precip rate mm/hr 
float paraccm=-99.;		// current parsivel precip accumulation in mm 
char parcmd[80]={0};		// keyboard comand for parsivel

// poss variables 
char RxPoss[8192]={0};		// (sposs) packet of data 
float posrate = -99.;		// current poss precip rate mm/hr 
float posaccm = -99.;		// current poss precip accumulation in mm (resets on power cycle only) 
float posaccmsod = 0.0;		// poss accumulation at the Start Of Day 
float posaccmtdy = -99.;		// daily accumulation for summary file (posaccm-posaccmsod) 

char RxVis[256]={0};        //char svis[256]={0};// one line of data 
float visrate = -99.;		// current vis precip rate mm/hr 
float visaccm = -99.;		// current vis precip accumulation in mm 

char RxAux[25]={0};        // Auxilary Device Rx buffer

typedef struct
{
 int ComPort;     // fh
 int ReadChCount; //nchar
 int RxCharIndex; //pchar
 char RecFlag;
 unsigned char dumpline; //initialy = 1
 int minmsgfail;
 char comstring[16];
 char present;
 char sendmail;	// Y to send email messages 
 char mailsent;
 //char *Rxptr;
}Serial;

Serial Pos = {0,0,0,0,1,0,"/dev/ttyUSB2",0,1,0};
Serial Parsivel = {0,0,0,0,1,0,"/dev/ttyUSB1",0,1,0};
Serial PWD = {0,0,0,0,1,0,"/dev/ttyUSB3",0,1,0};
Serial AuxDevice = {0,0,0,0,1,0,"/dev/ttyS1",0,0,0};

char ParFileMailSent = 0; //used for Parametar file related emails

struct timeb tstart;	// ftime - start 
struct timeb tfinish;
struct tm *newtime;

struct termios newtio;

// keyboard variables 
static struct termios initial_settings, new_settings; 
char kbchar;
int kbptr=0;
char kbword[80]={0};
int posrawd=0;		// dump all poss raw characters 

// email variables 

// default parameter file variables 
char pardate[70]="19APR2007/jws";
char site[4]="WXX";	// 3 letter site id 
char maildest[512]="steven.brady@ec.gc.ca";	// separate with ; 

typedef struct
     {
       unsigned char hour;
       unsigned char min;
       unsigned char sec;
       unsigned char day;
       unsigned char month;
       unsigned int year;
       unsigned char timeptr[32];     // Fri May 14 hh:mm:ss yyyy
       unsigned char auxtimeptr[22];  //hh:mm:ss,mm/dd/yy
       unsigned char timeonly[12];    //hh:mm:ss
       char CurrDateTime[22];         //mm/dd/yyyy hh:mm:ss
       unsigned int seconds_in_day;
     } LocalTime;

LocalTime CurrentTime,OldTime;

#define PARFILELINES 10  // (number of lines in PAR file)

#define 	MAXFAULTSINDEX 		20

#define 	POSMIN		0	
#define		POSDAY		1
#define 	HOTMIN		2
#define		HOTDAY		3	
#define         PARMIN		4
#define		PARDAY		5
#define		VISMIN		6
#define		VISDAY		7
#define 	TXPWR		8
#define 	PARFILE		9
#define 	CONFIGFILE	10
#define 	LVPROPEN	11
#define 	LVPRLONG	12
#define 	NOLOGER		13
#define 	CHKLOGER 	14
#define 	AUXMIN		15
#define		AUXDAY		16	

#define		PARFILEOPEN	17	
#define		PARFILEERR	18	

unsigned int Faults[MAXFAULTSINDEX] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; //0-fult/min;1-fault/day;2-upsfault/min;3-upsfault/day;4 - 

char message_2[] = "Par File unknown parameter\n";
char message_3[] = "Parameter file POSACQ1.PAR was not found, will use defaults\n";

unsigned char FlagKeyboardMsg = 0;   
// ==================================================================================================================================
#if (DEBUG == 0)
 main(int argc, char *argv[])
#else
 main()
#endif
{
	//curdatetim();	// get current date time 
#if (DEBUG == 0)
	   if(argc>1)
             {                
                sscanf(argv[1],"%s",&InParFileName);
             }      
           else
           {
	    printf("Usage: possacq parfilename\n");
            printf("e.g. possacq POSACQ1.PAR\n");
	    exit(0);
          }

        //printf("PARFILE,argc,a1,a2: %s, %i,%s,%s",InParFileName,argc,argv[0],argv[1]);
#else

strcpy(InParFileName,"/home/vlados/operator/POSACQ1.PAR");

#endif

        ftime(&tstart);
        Timing();

        printf("Starting...\n\n");

        Parsivel.sendmail = 0;
        PWD.sendmail = 0;
        PWD.present = 0;
        Parsivel.present = 0;

        ReadParFile(0);	        // get parameters without attempt to write into files 
        CreatePaths();          //create folowing paths: parpath[30]="/home/***/***/data/";
                                //possaccfile[36] = "/home/***/***/posaccmsod.txt";
                                //char TempMailFile[] = "/home/***/***/lastmailmes";
				//where ***/*** is mainpath specified in parametar file


        CreateLogDate(&CurrentTime,auxlogfile); //create:auxlogfile:yyyymmdd.log.This is used later to extract yyyymmdd for other filenames
        CreateMainMsgFile();
      
//      ReadParFile(0);	        // get parameters without attempt to write into files 
	CreateParFile();	// make today's filename for parsivel data
        CreateMsgFile();
        CreatePNGFile();
	
        ReadParFile(1);	// get parameters 
        OldTime.day = CurrentTime.day;
        OldTime.min = CurrentTime.min;

        Startup();	// initialize tty ports etc. 

// -------------------------------------- Test Area ----------------------------------

// -------------------------------------- End of Test Area ----------------------------------
//	while(going)	// forever loop 
//while(kbchar = getchar() != 'e')
// putchar(kbchar);



        for(;;)
	{
          Timing();
//--------------------------------------------
            if(Pos.present && Pos.RecFlag)
             {
               Pos.RecFlag = 0;
               ExtractPossData();
             }
           
            if(AuxDevice.present && AuxDevice.RecFlag)
               { 
                   AuxDevice.RecFlag = 0;
                   ExtractAuxDevice();
               }
            if(Parsivel.present && Parsivel.RecFlag)
             {
               Parsivel.RecFlag = 0;
               ExtractParsivelData();
            }

            if(PWD.present && PWD.RecFlag)
             {
               PWD.RecFlag = 0;
               ExtractVis();
            }
//--------------------------------------------
            if(FlagKeyboardMsg)
             {
                FlagKeyboardMsg = 0;
                ExtractKeyboard(kbword);
             }   

          testday();	// see if the day has changed 
	  testmin();	// see if the min has changed 
	
	nloops++;	// count times through loop in 1 minute 	
	//usleep(125000);	// sleep for 125 msec, tuned for nloops=~480/minute

       do{
           if(Pos.present) 	
             GetPossSerialData();
           if(Parsivel.present) 	
            GetParsivelSerialData();
           if(PWD.present) 	
            GetVisSerialData();

           if(AuxDevice.present)                
              checkmicro();

            checkkybd_1();
	  } while(usleep(125000)!=0);	// sleep for 125 msec, tuned for nloops=~476/minute usleep(125000)
  }// end of for loop
}// end of main	
/************************************************/

// ************ ROUTINES ********************

Startup()
{
unsigned char i;
FILE *fp;
FILE *fpp;
// initialize anything that needs it, especially the tty ports 

	printf("Software Version: %s\n",VERDATE); 
	system("setterm -blank 0");	// disable screen blanking 
	printf("startup()\n"); 
	
	//stimline = ctime(&(tstart.time));
	//acqtimline = ctime(&(tstart.time));
	//if(acqtimline[8]==' ') 
        //      acqtimline[8]='0';  // gcc ctime uses space 
	//if(acqtimline[15]=='1'||acqtimline[15]=='3'||acqtimline[15]=='5'|| acqtimline[15]=='7'||acqtimline[15]=='9')
	//   acqtimline[15] = (acqtimline[15]-1);

//	printf("Startup time = %.19s %s\n",stimline, &stimline[20]);
	printf("Startup time: %s\n",CurrentTime.timeptr); 
//stimline:Fri May 14 hh:mm:ss yyyy
// ------------------------------ initialize and open /dev/ttyUSB1 for parsivel packets ------------------------------------ 
//#if (DEBUG == 0)
//parscomstring[16];
//poscomstring[16];
//viscomstring[16];

//	Parsivel.ComPort = open("/dev/ttyUSB1", O_RDWR | O_NOCTTY);
if(Parsivel.present)
 {
	Parsivel.ComPort = open(Parsivel.comstring, O_RDWR | O_NOCTTY);
	if(Parsivel.ComPort < 0) 
         {
//          perror("/dev/ttyUSB1 open failed");
          perror("Parsivel com port open failed");
           exit(-1);
        }

	bzero(&newtio, sizeof(newtio));
	newtio.c_cflag=B9600 | CS8 | CLOCAL | CREAD;
	newtio.c_iflag=IGNPAR | IGNBRK;
	newtio.c_oflag=0;
	newtio.c_lflag=0;      // non-canonical, no echo ...
	newtio.c_cc[VTIME]=0;  // intercharacter timer unused 
	newtio.c_cc[VMIN]=0;   // don't block read 
	tcflush(Parsivel.ComPort, TCIFLUSH);
	if(tcsetattr(Parsivel.ComPort, TCSANOW, &newtio) != 0) 
          perror("tcsetattr failed");

//	printf("got to the bottom of initUSB1.\n");
	printf("got to the bottom of init %s\n",Parsivel.comstring);
	
} //end of if Parsivel

//	Pos.ComPort = open("/dev/ttyUSB2", O_RDONLY | O_NOCTTY);
if(Pos.present)
 {
        //printf("%s\n",Pos.comstring);
	Pos.ComPort = open(Pos.comstring, O_RDONLY | O_NOCTTY);
	if(Pos.ComPort < 0) 
          {
//            perror("/dev/ttyUSB2 open failed"); 
            perror("POSS Com Port open failed"); 
            exit(-1);
          }
//	printf("got to the bottom of initUSB2.\n");
	bzero(&newtio, sizeof(newtio));
//	newtio.c_cflag=B9600 | CS7 | CLOCAL | CREAD | PARENB;
	newtio.c_cflag=B1200 | CS7 | CLOCAL | CREAD | PARENB;
	newtio.c_iflag=IGNPAR | IGNBRK;
	newtio.c_oflag=0;
	newtio.c_lflag=0;      // non-canonical, no echo ...
	newtio.c_cc[VTIME]=0;   // intercharacter timer unused 
	newtio.c_cc[VMIN]=0;   // don't block read 

	tcflush(Pos.ComPort, TCIFLUSH);
	if(tcsetattr(Pos.ComPort, TCSANOW, &newtio) != 0) 
              perror("tcsetattr failed");

	printf("got to the bottom of init %s\n",Pos.comstring);
} //end of if Pos present
	//PWD.ComPort = open("/dev/ttyUSB3", O_RDWR | O_NOCTTY);
if(AuxDevice.present)
{
	AuxDevice.ComPort = open(AuxDevice.comstring, O_RDWR | O_NOCTTY);
	if(AuxDevice.ComPort < 0) 
          {
           perror("Auxiliary Device Com Port open failed"); 
           exit(-1);
          }

	bzero(&newtio, sizeof(newtio));
	newtio.c_cflag=B9600 | CS8 | CLOCAL | CREAD;
	newtio.c_iflag=IGNPAR | IGNBRK;
	newtio.c_oflag=0;
	newtio.c_lflag=0;      // non-canonical, no echo ...
	newtio.c_cc[VTIME]=0;  // intercharacter timer unused 
	newtio.c_cc[VMIN]=0;   // don't block read 

	tcflush(AuxDevice.ComPort, TCIFLUSH);
	if(tcsetattr(AuxDevice.ComPort, TCSANOW, &newtio) != 0)
             perror("tcsetattr failed");

//	printf("got to the bottom of init_TTYS1.\n");
	printf("got to the bottom of init %s\n",AuxDevice.comstring);
}
if(PWD.present)
 {
//       printf("paspwd\n");

	PWD.ComPort = open(PWD.comstring, O_RDWR | O_NOCTTY);
	if(PWD.ComPort < 0) 
          {
   //        perror("/dev/ttyUSB3 open failed");
           perror("Vis Com Port open failed");
           exit(-1);
         }

	bzero(&newtio, sizeof(newtio));
	newtio.c_cflag=B9600 | CS7 | CLOCAL | CREAD | PARENB;
	newtio.c_iflag=IGNPAR | IGNBRK;
	newtio.c_oflag=0;
	newtio.c_lflag=0;      // non-canonical, no echo ...
	newtio.c_cc[VTIME]=0;  // intercharacter timer unused 
	newtio.c_cc[VMIN]=0;   // don't block read 
	tcflush(PWD.ComPort, TCIFLUSH);
	if(tcsetattr(PWD.ComPort, TCSANOW, &newtio) != 0) 
            perror("tcsetattr failed");

//	printf("got to the bottom of initUSB3.\n");
	printf("got to the bottom of init %s\n",PWD.comstring);
 } //end of if PWD present
//#endif	
	// initialize keyboard 

	tcgetattr(0,&initial_settings);
	new_settings=initial_settings;
	new_settings.c_lflag &= ~ICANON;
	new_settings.c_lflag &= ~ISIG;
	new_settings.c_cc[VMIN]  = 0;
	new_settings.c_cc[VTIME] = 0;
	tcsetattr(0, TCSANOW, &new_settings);

	// initialize keyboard variables
	kbptr=0;		// for keyboard input 

        for(i = 0;i < 80;i++)
            kbword[i]=0;     // clear out kbword 


        //oldmin = CurrentTime.min%10; //vs
    OldTime.min = CurrentTime.min;
	

	fp=fopen(MessageFile,"a");
	  fprintf(fp,"%s starting %s %s\n",CurrentTime.timeonly,VERDATE,site);
	fclose(fp);

       if (Parsivel.present)
         {
             fp=fopen(mesparlog,"a");
	       fprintf(fp,"%i,%s starting %s %s\n",Faults[PARDAY],CurrentTime.CurrDateTime,VERDATE,site);
             fclose(fp);
          }
       if (Pos.present)
        {
	fp=fopen(mesposlog,"a");
          fprintf(fp,"%i,%s starting %s %s\n",Faults[POSDAY],CurrentTime.CurrDateTime,VERDATE,site);
	fclose(fp);

	}
       if (PWD.present)
       {
	fp=fopen(mesvislog,"a");
	  fprintf(fp,"%i,%s starting %s %s\n",Faults[VISDAY],CurrentTime.CurrDateTime,VERDATE,site);
	fclose(fp);
       }
	// read the pos start of day accumulation value 
	//fp=fopen("/home/posacq/posacq/posaccmsod.txt","r"); // read existing value
//#if (DEBUG == 0) //vs - check if file exist 
//	if(fp=fopen(possaccfile,"r") != NULL) // read existing value
//         { 
//	  fscanf(fp,"%f\n",&posaccmsod);
//	  printf("posaccmsod=%f\n",posaccmsod);
//	  fclose(fp);
//        }
//       else
//        {
//	  printf("%s Could not open possaccfile\n",CurrentTime.timeonly);
// 	  fpp=fopen(MessageFile,"a");
//	  fprintf(fpp,"%s Could not open possaccfile\n",CurrentTime.timeonly);
//	  fclose(fpp);
//        }
//#endif
	ftime(&tfinish);
	printf("Startup time was %2.2f seconds. \n",difftime(tfinish.time,tstart.time));
}// End of Startup ()
// =============================================================================================================
parcommand()
{
// output the string that was entered 

int nchar,nchar1;
int i;
FILE *fp;

	nchar1 = strlen(parcmd);
	parcmd[nchar1-1] = 0x0D;	// insert the cr 

	for(i=0;i < nchar1;i++) 
           parcmd[i] = toupper(parcmd[i]);

	nchar = write(Parsivel.ComPort,&parcmd,nchar1); // send the command 

	if(nchar == -1)
          {
	   Faults[PARMIN] += 1;
           Faults[PARDAY] += 1;
	   printf("%i,parcommand() write failed\n",Faults[PARDAY]);
	   // write to message file 
	   fp=fopen(mesparlog,"a");
	   fprintf(fp,"%i,%s parcommand() write failed\n",Faults[PARDAY],CurrentTime.CurrDateTime);
	   fclose(fp);
	}
	else
   {
	   Faults[PARMIN] += 1;
           Faults[PARDAY] += 1;
	   printf("%i,%s,parcommand() wrote %i chars <%.7s>\n",Faults[PARDAY],CurrentTime.CurrDateTime,nchar,parcmd);
	   // write to message file
	   fp=fopen(mesparlog,"a");
	   fprintf(fp,"%i,%s parcommand() wrote %i chars <%.7s>\n",Faults[PARDAY],CurrentTime.CurrDateTime,nchar,parcmd);
	   fclose(fp);
	}
} // end of parcommand() 
/****************************************************************/
// ==============================================================================
testday()
{
FILE *fp;

        if(CurrentTime.day != OldTime.day) // the units of day has changed 
          {
           OldTime.day = CurrentTime.day;

            summaryemail(" -ssummary"); 	 // send a summary email 

            //dailyplots();	 // generate the daily plots 

            CreateLogDate(&CurrentTime,auxlogfile); //create:auxlogfile:yyyymmdd.log.This is used later to extract yyyymmdd for other filenames
            CreateMainMsgFile();

    	    CreateParFile();	 // make new log file names 
            CreateMsgFile();
            CreatePNGFile();

	    Faults[PARDAY] = 0;
	    Faults[POSDAY] = 0;
	    Faults[VISDAY] = 0;
	    Faults[AUXDAY] = 0;

	    Faults[PARFILEOPEN] = 0;
	    Faults[PARFILEERR] = 0;

            if(Parsivel.present)	    
              resetpar();	// reset the parsivel accumulation
            if(PWD.present) 
	     visreset();	// reset the vis FD12P accumulation 

	// save the poss accumulation at the start of the day, to subtract for the rest of the day
	posaccmsod = posaccm;	// poss accum at start of day 
	//fp=fopen("/home/posacq/posacq/posaccmsod.txt","w"); //overwrite existing value
        fp = fopen(possaccfile,"w");     //overwrite existing value
	fprintf(fp,"%f\n",posaccmsod);
	fclose(fp);
  } // end of day has changed 
//================================================================
if(CurrentTime.hour != OldTime.hour)
     {
	 Parsivel.mailsent = 0;
	 Pos.mailsent = 0;
	 PWD.mailsent = 0;
         AuxDevice.mailsent = 0;
         ParFileMailSent = 0;
	 //oldhr=acqtimline[12];	
         OldTime.hour=CurrentTime.hour;
    }
} // end of testday()
/****************************************************************/
/****************************************************************/
testmin()
{
  FILE *fp;
 int selector = 0; // 1 - POS;2 - Aux; 4 - Parsivel; 8 - VIS

    if(CurrentTime.min != OldTime.min)	 // the units of mins has changed 
      {
	  OldTime.min = CurrentTime.min;

//MessageFile

         if(Parsivel.present)
          {
            if(Parsivel.minmsgfail < 65535)            
               Parsivel.minmsgfail++;//minnopar++;

	     if(Parsivel.minmsgfail >= 3)
              {
	   	Faults[PARMIN] += 1;
           	Faults[PARDAY] += 1;
	   // write to message file 
	   	printf("%i,%s no good parsivel lines in %i minutes.\n",Faults[PARDAY],CurrentTime.CurrDateTime,Parsivel.minmsgfail);
	   	fp=fopen(mesparlog,"a");
	   	fprintf(fp,"%i,%s no good parsivel lines in %i minutes.\n",Faults[PARDAY],CurrentTime.CurrDateTime,Parsivel.minmsgfail);
	   	fclose(fp);

	       fp=fopen(MessageFile,"a");
	       fprintf(fp,"%s,ParDayFaults: %i no good parsivel lines in %i minutes.\n",CurrentTime.timeonly,Faults[PARDAY],Parsivel.minmsgfail);
	      fclose(fp);

	     } // end of minnopar>=3 
         if(Faults[PARMIN] > 0)
          {
	   printf("Parsivel Faults[PARMIN]=%i Faults[PARDAY]=%i\n",Faults[PARMIN],Faults[PARDAY]);
          
           if((Parsivel.sendmail == 1) && (Parsivel.mailsent == 0))
              selector |= 0x04;  
   
 	   //paremail(); 	  //send email message
          // FaultMail(" -sparfail",&Parsivel,Faults[PARMIN],Faults[PARDAY]);
          }
        }  
//------------------------------------------------------
       if(Pos.present)
       {  
         if(Pos.minmsgfail < 65535)
            Pos.minmsgfail++;    //minnopos++;

	 if(Pos.minmsgfail >= 3)
           {
	    Faults[POSMIN] += 1;
            Faults[POSDAY] += 1;
	   // write to message file 
	    printf("%i,%s no good poss packets in %i minutes.\n",Faults[POSDAY],CurrentTime.CurrDateTime,Pos.minmsgfail);
	    fp=fopen(mesposlog,"a");
	    fprintf(fp,"%i,%s no good poss packets in %i minutes.\n",Faults[POSDAY],CurrentTime.CurrDateTime,Pos.minmsgfail);
	    fclose(fp);

	fp=fopen(MessageFile,"a");
	fprintf(fp,"%s,PosDayFaults: %i no good poss packets in %i minutes.\n",CurrentTime.timeonly,Faults[POSDAY],Pos.minmsgfail);
	fclose(fp);
	   } // end of minnopos>=3

        if(Faults[POSMIN] > 0)	 // check for poss  fails this minute 
         {
	  printf("Pos Faults[POSMIN]=%i Faults[POSDAY]=%i\n",Faults[POSMIN],Faults[POSDAY]);

           if((Pos.sendmail == 1) && (Pos.mailsent == 0))
            selector |= 0x01;     

	  //posemail();   // send email message 
//           FaultMail(" -sposfail",&Pos,Faults[POSMIN],Faults[POSDAY]);
	  } // end of Faults[POSMIN]>=1 
       }
//------------------------------------------------------
       if(AuxDevice.present)
       {  
           if (AuxDevice.minmsgfail < 65535)         
              AuxDevice.minmsgfail++;    //minnopos++;

	 if(AuxDevice.minmsgfail >= 3)
           {
	    Faults[AUXMIN] += 1;
            Faults[AUXDAY] += 1;
	   // write to message file 
          fp=fopen(MessageFile,"a");
	  fprintf(fp,"%s,AuxDayFaults: %i no good Aux Device packets in %i minutes.\n",CurrentTime.timeonly,Faults[AUXDAY],AuxDevice.minmsgfail);
	  fclose(fp);
        } // end of minnopos>=3
       
     if(Faults[AUXMIN] > 0)	 // check for poss  fails this minute 
         {
           
	  printf("Aux Device Faults[AUXMIN]=%i Faults[AUXDAY]=%i\n",Faults[AUXMIN],Faults[AUXDAY]);

           if((AuxDevice.sendmail == 1) && (AuxDevice.mailsent == 0))
              selector |= 0x02;     

	  //posemail();   // send email message 
           //FaultMail(" -sposfail",&AuxDevice,Faults[AUXMIN],Faults[AUXDAY]);
	  } // end of Faults[POSMIN]>=1 
       }

     if(PWD.present)
       {
         if(PWD.minmsgfail < 65535)
          PWD.minmsgfail++;//minnovis++;	// increment minutes with no valid data 

	 if(PWD.minmsgfail >= 3)
           {
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   // write to message file 
	   printf("%i,%s no good vis lines in %i minutes.\n",Faults[VISDAY],CurrentTime.CurrDateTime,PWD.minmsgfail);
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s no good vis lines in %i minutes.\n",Faults[VISDAY],CurrentTime.CurrDateTime,PWD.minmsgfail);
	   fclose(fp);

	    fp=fopen(MessageFile,"a");
	    fprintf(fp,"%s,VisDayFaults: %i no good vis lines in %i minutes.\n",CurrentTime.timeonly,Faults[VISDAY],PWD.minmsgfail);
	    fclose(fp);
	   } // end of minnovis>=3

        if(Faults[VISMIN] > 0)	 // check for vis  fails this minute 
         {
	  printf("VIS Faults[VISMIN]=%i Faults[VISDAY]=%i\n",Faults[VISMIN],Faults[VISDAY]);

           if((PWD.sendmail == 1) && (PWD.mailsent == 0))
            selector |= 0x08;     
	  //visemail();// send email message 
           //FaultMail(" -svisfail",&PWD,Faults[VISMIN],Faults[VISDAY]);
	  } // end of Faults[VISMIN]>=1  
	}
//------------------------------------------------ PAR FILE ERROR MAIL ---------------------------------------------------------
	if((ParFileMailSent == 0) && ((PWD.sendmail == 1) || (Pos.sendmail == 1) || (Parsivel.sendmail == 1) || (AuxDevice.sendmail == 1)))
           {
              if(Faults[PARFILEOPEN] || Faults[PARFILEERR])
                selector |= 0x80;    
           }
//------------------------------------------------------------------------------------------------------------------------------
       if(selector)
          FaultMail(" -sfail",selector);
//------------------------------------------------------
//--------------------- New Output starting with Version 1.3 ----------------------------------------------
	 printf("%s ",CurrentTime.CurrDateTime);

//         if(Parsivel.present)
//           printf(",%8.2f,%8.2f",parrate,paraccm);

//         if(Pos.present)
//           printf(",%8.2f,%8.2f",posrate,posaccmtdy);

//         if(PWD.present)
//           printf(",%8.2f,%8.2f",visrate,visaccm);

//	 printf("\n");
   
	 // set values to -99. for missing data 

         parrate=-99.;paraccm=-99.;
         posrate=-99.;posaccm=-99.;posaccmtdy=-99.;
         visrate=-99.;visaccm=-99.;

	 //printf("nloops=%i\n",nloops);
	 nloops=0;
 	 //dailyplots();	// test plots here 
	 //oldmin=acqtimline[15];
	 Faults[PARMIN]= 0;
	 Faults[POSMIN]= 0;
	 Faults[VISMIN]= 0;
	 Faults[AUXMIN]= 0;

	 Faults[PARFILEOPEN]= 0;
	 Faults[PARFILEERR]= 0;
         
	} // end of mins has changed 
} // end of testmin()

// ===================================================================================
FaultMail(char *subject,int sel)
{
 char mailcmd[570];

 FILE *fp;

	//if(ptr->mailsent == 1)
        //  return(0);

	// only send email if requested 
	//if(ptr->sendmail == 0)
        //    return(0);

	fp=fopen(TempMailFile,"w");
//------------------------------------------------------------------------------------
   switch (sel)
      {
               case 1:
		fprintf(fp,"Pos Faults/Min: %i Faults/Day: %i\n",Faults[POSMIN],Faults[POSDAY]);
                Pos.mailsent = 1;
                break;     

               case 2:
		fprintf(fp,"Aux Faults/Min: %i Faults/Day: %i\n",Faults[AUXMIN],Faults[AUXDAY]);
                AuxDevice.mailsent = 1;
               break;

               case 3:
		fprintf(fp,"Pos Faults/Min: %i Faults/Day: %i\n",Faults[POSMIN],Faults[POSDAY]);
		fprintf(fp,"Aux Faults/Min: %i Faults/Day: %i\n",Faults[AUXMIN],Faults[AUXDAY]);
                Pos.mailsent = 1;
                AuxDevice.mailsent = 1;
               break;     
     
               case 4:
		fprintf(fp,"Parsival Faults/Min: %i Faults/Day: %i\n",Faults[PARMIN],Faults[PARDAY]);
                Parsivel.mailsent = 1;
               break;     

               case 5:
		fprintf(fp,"Pos Faults/Min: %i Faults/Day: %i\n",Faults[POSMIN],Faults[POSDAY]);
		fprintf(fp,"Parsival Faults/Min: %i Faults/Day: %i\n",Faults[PARMIN],Faults[PARDAY]);
                Pos.mailsent = 1;
                Parsivel.mailsent = 1;
               break;     

               case 6:
		fprintf(fp,"Aux Faults/Min: %i Faults/Day: %i\n",Faults[AUXMIN],Faults[AUXDAY]);
		fprintf(fp,"Parsival Faults/Min: %i Faults/Day: %i\n",Faults[PARMIN],Faults[PARDAY]);
                AuxDevice.mailsent = 1;
                Parsivel.mailsent = 1;
               break;
     
               case 7:
		fprintf(fp,"Pos Faults/Min: %i Faults/Day: %i\n",Faults[POSMIN],Faults[POSDAY]);
		fprintf(fp,"Aux Faults/Min: %i Faults/Day: %i\n",Faults[AUXMIN],Faults[AUXDAY]);
		fprintf(fp,"Parsival Faults/Min: %i Faults/Day: %i\n",Faults[PARMIN],Faults[PARDAY]);
                Pos.mailsent = 1;
                AuxDevice.mailsent = 1;
                Parsivel.mailsent = 1;
               break;     

               case 8:
		fprintf(fp,"VIS Faults/Min: %i Faults/Day: %i\n",Faults[VISMIN],Faults[VISDAY]);
                PWD.mailsent = 1;
               break;     

               case 9:
		fprintf(fp,"Pos Faults/Min: %i Faults/Day: %i\n",Faults[POSMIN],Faults[POSDAY]);
		fprintf(fp,"VIS Faults/Min: %i Faults/Day: %i\n",Faults[VISMIN],Faults[VISDAY]);
                Pos.mailsent = 1;
                PWD.mailsent = 1;
               break;     

               case 10:
		fprintf(fp,"Aux Faults/Min: %i Faults/Day: %i\n",Faults[AUXMIN],Faults[AUXDAY]);
		fprintf(fp,"VIS Faults/Min: %i Faults/Day: %i\n",Faults[VISMIN],Faults[VISDAY]);
                AuxDevice.mailsent = 1;
                PWD.mailsent = 1;
               break;     

               case 11:
		fprintf(fp,"Pos Faults/Min: %i Faults/Day: %i\n",Faults[POSMIN],Faults[POSDAY]);
		fprintf(fp,"Aux Faults/Min: %i Faults/Day: %i\n",Faults[AUXMIN],Faults[AUXDAY]);
		fprintf(fp,"VIS Faults/Min: %i Faults/Day: %i\n",Faults[VISMIN],Faults[VISDAY]);
                Pos.mailsent = 1;
                AuxDevice.mailsent = 1;
                PWD.mailsent = 1;
               break;     

               case 12:
		fprintf(fp,"Parsival Faults/Min: %i Faults/Day: %i\n",Faults[PARMIN],Faults[PARDAY]);
		fprintf(fp,"VIS Faults/Min: %i Faults/Day: %i\n",Faults[VISMIN],Faults[VISDAY]);
                Parsivel.mailsent = 1;
                PWD.mailsent = 1;
               break;     

               case 13:
		fprintf(fp,"Pos Faults/Min: %i Faults/Day: %i\n",Faults[POSMIN],Faults[POSDAY]);
		fprintf(fp,"Parsival Faults/Min: %i Faults/Day: %i\n",Faults[PARMIN],Faults[PARDAY]);
		fprintf(fp,"VIS Faults/Min: %i Faults/Day: %i\n",Faults[VISMIN],Faults[VISDAY]);
                Pos.mailsent = 1;
                Parsivel.mailsent = 1;
                PWD.mailsent = 1;
               break;     

               case 14:
		fprintf(fp,"Aux Faults/Min: %i Faults/Day: %i\n",Faults[AUXMIN],Faults[AUXDAY]);
		fprintf(fp,"Parsival Faults/Min: %i Faults/Day: %i\n",Faults[PARMIN],Faults[PARDAY]);
		fprintf(fp,"VIS Faults/Min: %i Faults/Day: %i\n",Faults[VISMIN],Faults[VISDAY]);
                AuxDevice.mailsent = 1;
                Parsivel.mailsent = 1;
                PWD.mailsent = 1;
               break;

               case 15:
		fprintf(fp,"Pos Faults/Min: %i Faults/Day: %i\n",Faults[POSMIN],Faults[POSDAY]);
		fprintf(fp,"Aux Faults/Min: %i Faults/Day: %i\n",Faults[AUXMIN],Faults[AUXDAY]);
		fprintf(fp,"Parsival Faults/Min: %i Faults/Day: %i\n",Faults[PARMIN],Faults[PARDAY]);
		fprintf(fp,"VIS Faults/Min: %i Faults/Day: %i\n",Faults[VISMIN],Faults[VISDAY]);
                Pos.mailsent = 1;
                AuxDevice.mailsent = 1;
                Parsivel.mailsent = 1;
                PWD.mailsent = 1;
               break;   

              case 128:   
		fprintf(fp,"Parametar File Error:Openning PAR File: %i,Reading PAR File: %i\n",Faults[PARFILEOPEN],Faults[PARFILEERR]);
                ParFileMailSent = 1;
              break;

               default:  
             	fprintf(fp,"Unknown Fault\n");
               break;
     
      } //end switch             
//------------------------------------------------------------------------------------
//	fprintf(fp,"Faults/Min: %i Faults/Day: %i\n",fault_1,fault_2);
	fclose(fp);
	strcpy(mailcmd, "tail -2 ");
	strcat(mailcmd, MessageFile);
	strcat(mailcmd, " >> ");
	strcat(mailcmd, TempMailFile);
//	strcat(mailcmd, " >> /home/posacq/posacq/lastmailmes");
	system(mailcmd);
	printf("email message <%s>\n",mailcmd);
// --------------------- make email command---------------------- 
	strcpy(mailcmd,"mail");
	strcat(mailcmd,subject);
	strcat(mailcmd," ");
	strcat(mailcmd, maildest);

	strcat(mailcmd, " <");
	strcat(mailcmd, TempMailFile);

//	strcat(mailcmd," </home/posacq/posacq/lastmailmes");
	system(mailcmd);
	printf("sent parfail email message <%s>\n",mailcmd);

//	ptr->mailsent = 1;	

} //end of FaultMail()
// ===================================================================================
summaryemail(char *subject)
{
char mailcmd[570];
FILE *fp;
	// only send email if requested 
	if((Parsivel.sendmail  == 0) && (Pos.sendmail  == 0) && (PWD.sendmail == 0) && (AuxDevice.sendmail == 0)) 
           return(0);

	// make the mail message file 
//	fp=fopen("/home/posacq/posacq/summarymailmes","w");
	fp=fopen(TempMailFile,"w");

	fprintf(fp,"%s\n",CurrentTime.CurrDateTime);

        if(Pos.present)
	 fprintf(fp,"Faults[POSDAY]: %i\n",Faults[POSDAY]);
        if(AuxDevice.present)
	 fprintf(fp,"Faults[AUXDAY]: %i\n",Faults[AUXDAY]);
        if(PWD.present)
	 fprintf(fp,"Faults[VISDAY]: %i\n",Faults[VISDAY]);
        if(Parsivel.present)
	 fprintf(fp,"Faults[PARDAY]: %i\n",Faults[PARDAY]);
        fclose(fp);
	
// make email command 
	strcpy(mailcmd,"mail");
//	strcat(mailcmd," -ssummary");
	strcat(mailcmd,subject);
	strcat(mailcmd," ");
	strcat(mailcmd, maildest);

	strcat(mailcmd, " <");  
	strcat(mailcmd, TempMailFile);
//	strcat(mailcmd," </home/posacq/posacq/lastmailmes"); 
	system(mailcmd);
	printf("sent summary email message <%s>\n",mailcmd);

} //end of hsummarymail() 
/**********************************************************/
/*
dailyplots()
{
FILE *fp;
char tmp[60];
	// daily parsivel plot
	// open and write to the gnuplot file 
	// use %% for %, \" for " and \' for ' 
if(Parsivel.present)
 {
//#if(DEBUG == 1)
//if((fp=fopen("/home/vlados/operator/plotcmdpar.txt","w")) != NULL)
//#else
//if((fp=fopen("/home/posacq/posacq/plotcmdpar.txt","w")) != NULL)
//#endif	
 strcpy(tmp,mainpath);
 strcat(tmp, "plotcmdpar.txt");
if((fp=fopen(tmp,"w")) != NULL)
 {
//	fp=fopen("/home/posacq/posacq/plotcmdpar.txt","w");
	// set up the type of terminal 
	fprintf(fp,"set terminal png\n");
	fprintf(fp,"set output \"%s\"\n",parpnglog);
	// set up some stuff 
	fprintf(fp,"set datafile separator \",\"\n");
	fprintf(fp,"set datafile missing \"-99.00,\" \n");
	fprintf(fp,"set title \"Parsivel Rainrate %s %s\" \n",
                    site,plotdate);
	// set up x axis for time 
	fprintf(fp,"set xdata time\n");
	fprintf(fp,"set timefmt \"%%H:%%M:%%S\"\n");
	// start plot at minute 01:00 (not 00:00) so we skip the 00:00 line which usually has
        //   the accumulation value from 23:59:59 of the previous day 
	fprintf(fp,"set xrange [\"00:01:00\":\"23:59:59\"]\n");
	fprintf(fp,"set format x \"%%H:%%M\" \n");
	fprintf(fp,"set xlabel \"Time (HH:MM Z)\" \n");
	// set up y axes
	fprintf(fp,"set ylabel \"Rainrate (mm/hr)\" \n");
	fprintf(fp,"set yrange [0:*]\n");
	fprintf(fp,"set y2label \"Rain Accumulation (mm)\" \n");
	fprintf(fp,"set y2range [0:*]\n");
	fprintf(fp,"set ytics nomirror \n");
	fprintf(fp,"set y2tics nomirror \n");
	// plot the data 
	fprintf(fp,"plot \'%s\' using 2:($5) title \"Parsivel Rate \"  with lines, \\\n",sumlog);
	fprintf(fp,"     \'%s\' using 2:($6) title \"Parsivel Accum\" with lines axes x1y2\n",sumlog);
	fclose(fp);

	system("gnuplot plotcmdpar.txt");
}
else
{
   printf("\n");
   fp=fopen(MessageFile,"a");
   fprintf(fp,"%s,Failed to open plotcmdpar.txt file\n",CurrentTime.timeonly);
   fclose(fp);
  }
 }
	// daily poss plot 
	// open and write to the gnuplot file 
	// use %% for %, \" for " and \' for ' 
if(Pos.present)
 {
//#if(DEBUG == 1)
//if((fp=fopen("/home/vlados/operator/plotcmdpos.txt","w")) != NULL)
//#else
 strcpy(tmp,mainpath);
 strcat(tmp, "plotcmdpos.txt");
 if((fp=fopen(tmp,"w")) != NULL)
//#endif	
//if((fp=fopen("/home/posacq/posacq/plotcmdpos.txt","w")) != NULL)
         {
	//fp=fopen("/home/posacq/posacq/plotcmdpos.txt","w");
	// set up the type of terminal
	fprintf(fp,"set terminal png\n");
	fprintf(fp,"set output \"%s\"\n",pospnglog);
	// set up some stuff 
	fprintf(fp,"set datafile separator \",\"\n");
	fprintf(fp,"set datafile missing \"-99.00,\" \n");
	fprintf(fp,"set title \"Poss Rainrate %s %s\" \n",
                    site,plotdate);
	// set up x axis for time 
	fprintf(fp,"set xdata time\n");
	fprintf(fp,"set timefmt \"%%H:%%M:%%S\"\n");
	// start plot at minute 01:00 (not 00:00) so we skip the 00:00 line which usually has
        //   the accumulation value from 23:59:59 of the previous day 
	fprintf(fp,"set xrange [\"00:01:00\":\"23:59:59\"]\n");
	fprintf(fp,"set format x \"%%H:%%M\" \n");
	fprintf(fp,"set xlabel \"Time (HH:MM Z)\" \n");
	// set up y axes 
	fprintf(fp,"set ylabel \"Rainrate (mm/hr)\" \n");
	fprintf(fp,"set yrange [0:*]\n");
	fprintf(fp,"set y2label \"Rain Accumulation (mm)\" \n");
	fprintf(fp,"set y2range [0:*]\n");
	fprintf(fp,"set ytics nomirror \n");
	fprintf(fp,"set y2tics nomirror \n");
	// plot the data 
	fprintf(fp,"plot \'%s\' using 2:($7) title \"Poss Rate \"  with lines, \\\n",sumlog);
	fprintf(fp,"     \'%s\' using 2:($8) title \"Poss Accum\" with lines axes x1y2\n",sumlog);
	fclose(fp);

	system("gnuplot plotcmdpos.txt");
   }
else
{
   printf("\n");
   fp=fopen(MessageFile,"a");
   fprintf(fp,"%s,Failed to open plotcmdpos.txt file\n",CurrentTime.timeonly);
   fclose(fp);
}
 }
	// daily vis plot 
	// open and write to the gnuplot file 
	// use %% for %, \" for " and \' for ' 
if(PWD.present)
{
//#if(DEBUG == 1)
//if((fp=fopen("/home/vlados/operator/plotcmdvis.txt","w")) != NULL)
//#else
//if((fp=fopen("/home/posacq/posacq/plotcmdvis.txt","w")) != NULL)
//#endif	
 strcpy(tmp,mainpath);
 strcat(tmp, "plotcmdvis.txt");
 if((fp=fopen(tmp,"w")) != NULL)
{

//	fp=fopen("/home/posacq/posacq/plotcmdvis.txt","w");
	// set up the type of terminal 
	fprintf(fp,"set terminal png\n");
	fprintf(fp,"set output \"%s\"\n",vispnglog);
	// set up some stuff 
	fprintf(fp,"set datafile separator \",\"\n");
	fprintf(fp,"set datafile missing \"-99.00,\" \n");
	fprintf(fp,"set title \"PWD22 Rainrate %s %s\" \n",
                    site,plotdate);
	// set up x axis for time 
	fprintf(fp,"set xdata time\n");
	fprintf(fp,"set timefmt \"%%H:%%M:%%S\"\n");
	// start plot at minute 01:00 (not 00:00) so we skip the 00:00 line which usually has
        //   the accumulation value from 23:59:59 of the previous day 

	fprintf(fp,"set xrange [\"00:01:00\":\"23:59:59\"]\n");
	fprintf(fp,"set format x \"%%H:%%M\" \n");
	fprintf(fp,"set xlabel \"Time (HH:MM Z)\" \n");
	// set up y axes 
	fprintf(fp,"set ylabel \"Rainrate (mm/hr)\" \n");
	fprintf(fp,"set yrange [0:*]\n");
	fprintf(fp,"set y2label \"Rain Accumulation (mm)\" \n");
	fprintf(fp,"set y2range [0:*]\n");
	fprintf(fp,"set ytics nomirror \n");
	fprintf(fp,"set y2tics nomirror \n");
	// plot the data 
	fprintf(fp,"plot \'%s\' using 2:($9) title \"PWD22 Rate \"  with lines, \\\n",sumlog);
	fprintf(fp,"     \'%s\' using 2:($10) title \"PWD22 Accum\" with lines axes x1y2\n",sumlog);
	fclose(fp);

	system("gnuplot plotcmdvis.txt");
 }
else
{
   printf("\n");
   fp=fopen(MessageFile,"a");
   fprintf(fp,"%s,Failed to open plotcmdvis.txt file\n",CurrentTime.timeonly);
   fclose(fp);
 }
}

	// daily summary plot
	// open and write to the gnuplot file 
	// use %% for %, \" for " and \' for ' 
if(Parsivel.present && Pos.present && PWD.present)
 {
//#if(DEBUG == 1)
//if((fp=fopen("/home/vlados/operator/plotcmdsum.txt","w")) != NULL)
//#else
//if((fp=fopen("/home/posacq/posacq/plotcmdsum.txt","w")) != NULL)
//#endif	
 strcpy(tmp,mainpath);
 strcat(tmp, "plotcmdsum.txt");
 if((fp=fopen(tmp,"w")) != NULL)
 {
//	fp=fopen("/home/posacq/posacq/plotcmdsum.txt","w");
	// set up the type of terminal 
	fprintf(fp,"set terminal png\n");
	fprintf(fp,"set output \"%s\"\n",sumpnglog);
	// set up some stuff 
	fprintf(fp,"set datafile separator \",\"\n");
	fprintf(fp,"set datafile missing \"-99.00,\" \n");
	fprintf(fp,"set title \"Parsivel, POSS & PWD22 Rainrates %s %s\" \n",
                    site,plotdate);
	// set up x axis for time 
	fprintf(fp,"set xdata time\n");
	fprintf(fp,"set timefmt \"%%H:%%M:%%S\"\n");
	// start plot at minute 01:00 (not 00:00) so we skip the 00:00 line which usually has
         //  the accumulation value from 23:59:59 of the previous day 
	fprintf(fp,"set xrange [\"00:01:00\":\"23:59:59\"]\n");
	fprintf(fp,"set format x \"%%H:%%M\" \n");
	fprintf(fp,"set xlabel \"Time (HH:MM Z)\" \n");
	// set up y axes 
	fprintf(fp,"set ylabel \"Rainrate (mm/hr)\" \n");
	fprintf(fp,"set yrange [0:*]\n");
	fprintf(fp,"set y2label \"Rain Accumulation (mm)\" \n");
	fprintf(fp,"set y2range [0:*]\n");
	fprintf(fp,"set ytics nomirror \n");
	fprintf(fp,"set y2tics nomirror \n");
	// plot the data 
	//fprintf(fp,"plot \'%s\' using 2:($3) title \"Hotplate Rate\" with lines, \\\n",sumlog);
	fprintf(fp,"plot \'%s\' using 2:($5) title \"Parsivel Rate\" with lines, \\\n",sumlog);
	fprintf(fp,"     \'%s\' using 2:($7) title \"POSS Rate\" with lines, \\\n",sumlog);
	fprintf(fp,"     \'%s\' using 2:($9) title \"PWD22 Rate\" with lines, \\\n",sumlog);
	//fprintf(fp,"     \'%s\' using 2:($4) title \"Hotplate Accum\" with lines axes x1y2, \\\n",sumlog);
	fprintf(fp,"     \'%s\' using 2:($6) title \"Parsivel Accum\" with lines axes x1y2, \\\n",sumlog);
	fprintf(fp,"     \'%s\' using 2:($8) title \"POSS Accum\" with lines axes x1y2,\\\n",sumlog);
	fprintf(fp,"     \'%s\' using 2:($10) title \"PWD22 Accum\" with lines axes x1y2\n",sumlog);
	fclose(fp);

	system("gnuplot plotcmdsum.txt");
	printf("created daily plots.\n");
      }
    else
    {
     printf("\n");
     fp=fopen(MessageFile,"a");
     fprintf(fp,"%s,Failed to open plotcmdsum.txt file\n",CurrentTime.timeonly);
     fclose(fp);
   }

    }
} // end of daily plots 
*/
//===============================================================================

// the end of program SERACQ1.C 

Timing()
{
	// make date time string in format: char scurdatetim[21]="30/01/2007 13:59:59" 
        TimeHandling(&CurrentTime);
        GetTime(&CurrentTime);
        CreateScur(&CurrentTime);
//        CreateUPS(&CurrentTime,UPSday,UPStime,UPSmonth);
}	// end of curdatetime()
//================================================================================
//Create Following Strings:
// timeptr:Tue May 04 hh:mm:ss yyyy
// auxtimeptr:hh:mm:ss,mm:dd:yy
// timeonly:hh:mm:ss
//================================================================================
TimeHandling(LocalTime *tptr)
 {
   time_t now;
   struct tm *ptr;
   unsigned char *timeptr;

   time(&now);
   ptr = localtime(&now);

   strftime(tptr->auxtimeptr,22,"%X,%x",ptr);  //hh:mm:ss,mm/dd/yy
   strftime(tptr->timeonly,12,"%X",ptr);      //hh:mm:ss
   //puts(tptr->timeptr);
   strftime(tptr->timeptr,32,"%a %b %d %X %Y",ptr); //a - day (ab) b - month,d - date(dec),X-time)hh:mm:ss),%Y - year(yyyy)
// Fri May 14 hh:mm:ss yyyy 
//  puts(tptr->timeptr);

 }//end of TimeHandling()
//================================================================================
//PArse time string and Store hour, min, sec,day, month, year and daily seconds 
//================================================================================
GetTime(LocalTime *tptr)
{
//iNput is in format: Mon Apr 23 09:15:32 2010
 unsigned int localvar;
 unsigned char *ptr;

ptr = tptr->auxtimeptr;

 while(*ptr != ':')
    ++ptr;

 --(ptr);
  --(ptr);
 
localvar = ((*ptr)- '0');
++(ptr);
localvar *= 10;
localvar += ((*ptr)- '0');
++(ptr);
++(ptr);

tptr->hour = localvar;
tptr->seconds_in_day = localvar;
tptr->seconds_in_day *= 3600;

localvar = ((*ptr)- '0');
++(ptr);
localvar *= 10;
localvar += ((*ptr)- '0');
++(ptr);
++(ptr);

tptr->min = localvar;
tptr->seconds_in_day += (localvar*60);

localvar = ((*ptr)- '0');
++(ptr);
localvar *= 10;
localvar += ((*ptr)- '0');

tptr->sec = localvar;

tptr->seconds_in_day += tptr->sec;
//========================= Extract day,month,year ===============
 while(*ptr != '/')
    ++(ptr);

 --(ptr);
 --(ptr);


localvar = ((*ptr)- '0');
++(ptr);
localvar *= 10;
localvar += ((*ptr)- '0');
++(ptr);
++(ptr);

tptr->month = localvar;

localvar = ((*ptr)- '0');
++(ptr);
localvar *= 10;
localvar += ((*ptr)- '0');
++(ptr);
++(ptr);

tptr->day = localvar;

localvar = ((*ptr)- '0');
++(ptr);
localvar *= 10;
localvar += ((*ptr)- '0');
++(ptr);
++(ptr);

localvar += 2000;
tptr->year = localvar;
}
//================================================================================
CreateScur(LocalTime *sptr)
{
//Creating CurrDateTime.Format: dd/mm/yyyy,hh:mm:ss
  unsigned char *ptr,*out_1;
  unsigned char ii;
  unsigned char aux[9];
  
 ptr = sptr->auxtimeptr;
 out_1 = sptr->CurrDateTime;

 for(ii = 0;ii < 8;ii++)
  {
   aux[ii] = *ptr;
   ++ptr;
  }

  while (*ptr  != '/')
     ++ptr;

 ++ptr;

 *out_1 = *ptr;
//--------------- dd --------- 
 ++out_1;
 ++ptr;
 *out_1 = *ptr;
 ++out_1;
 *out_1 = '/';
 ++out_1;

 --ptr;
 --ptr;
 --ptr;
 --ptr;
//-------------------- mm -----------------
 *out_1 = *ptr;
 ++out_1;
 ++ptr;
 *out_1 = *ptr;
 ++out_1;
 *out_1 = '/';
//-------------------- yy ------------------
 ++out_1;
 ++ptr;
 ++ptr;
 ++ptr;
 ++ptr;
 ++ptr;
*out_1 = '2';
 ++out_1;
*out_1 = '0';
 ++out_1;

*out_1 = *ptr;
 ++out_1;
 ++ptr;
*out_1 = *ptr;
//--------------------- Time --------------------------------
++out_1;
*out_1 = ',';
++out_1;

*out_1 =  aux[0];
++out_1;
*out_1 =  aux[1];
++out_1;
*out_1 = aux[2];
++out_1;
*out_1 =  aux[3];
++out_1;
*out_1 =  aux[4];
++out_1;
*out_1 = aux[5];
++out_1;
*out_1 = aux[6];
++out_1;
*out_1 = aux[6];
}
//=========================================================================================================================
CreateLogDate(LocalTime *sptr,char *out_3)
{
//       CreateLogDate(&CurrentTime,logfilename);  // create: logfilename = yyyymmdd.log

  unsigned char *ptr;
  unsigned char ii;
  
 ptr = sptr->auxtimeptr; // hh:mm:ss,mm/dd/yy

 for(ii = 0;ii < 8;ii++)
   ++ptr;

  while (*ptr  != '/')
     ++ptr;

  ++ptr;

  while (*ptr  != '/')
     ++ptr;

  ++ptr;

*out_3++ = '2';
*out_3++ = '0';
*out_3++ = *ptr++;
*out_3++ = *ptr;

ptr -= 7;

if(*ptr == '0')
 {
   *out_3++ = *ptr++;
   *out_3++ = *ptr++;
 }
else
{
    *out_3++ = *ptr++;
    *out_3++ =*ptr++;
}
//   ++out_3;
   ++ptr;
   //++ptr;
   *out_3++ = *ptr++;
   *out_3++ =*ptr;
   *out_3++ = '.';
   *out_3++ = 'l';
   *out_3++ = 'o';
   *out_3++ = 'g';
   *out_3 = 0;

}
//=========================================================
CreatePOSTime(LocalTime *sptr,char *inout)
{
// format SPS091 yymmdd hh:mm 
  unsigned char *ptr;
  unsigned char ii;
  
  ptr = sptr->auxtimeptr; // hh:mm:ss,mm/dd/yy

  inout += 7;
  
  while(*ptr != ',')
   ptr++;

  ptr += 7; //jump to years

//------------------------------ extract years ------------------------
  *inout++ = *ptr++;
  *inout++ = *ptr;
//------------------------------ extract month ------------------------
  ptr -= 7; //jump to months
  *inout++ = *ptr++;
  *inout++ = *ptr++;

  ptr++;
//------------------------------ extract day ------------------------
  *inout++ = *ptr++;
  *inout++ = *ptr;
  
*inout++ = ' '; // insert space

 ptr -= 13; //jump to hours

  *inout++ = *ptr++;
  *inout++ = *ptr++;
  *inout++ = *ptr++;
  *inout++ = *ptr++;
  *inout = *ptr;


/*
	if(RxPoss[0]==0x01)
       {
	  RxPoss[7]=scurdatetim[8];	// tens years 
	  RxPoss[8]=scurdatetim[9];	// units years 
	  RxPoss[9]=scurdatetim[3];	// tens months 
	  RxPoss[10]=scurdatetim[4];	// units months 
	  RxPoss[11]=scurdatetim[0];	// tens days 
	  RxPoss[12]=scurdatetim[1];	// units days 
	  RxPoss[13]=' ';			
	  RxPoss[14]=scurdatetim[11];	// tens hours 
	  RxPoss[15]=scurdatetim[12];	// units hours 
	  RxPoss[16]=':';			// :  
	  RxPoss[17]=scurdatetim[14];	// tens mins 
	  RxPoss[18]=scurdatetim[15];	// units mins
	}
*/
}
//==================================================================================================
CreateLogFileName(char *prefix,char *out_1,char *out_2,char sel) //Create VISyyyymmdd.csv
{
 //sel = 1; txt
while(*prefix)
{
 *out_2++ = *prefix;
prefix++;
//*out_2++ = *prefix++;
// *out_2++ = *prefix++;
// *out_2++ = *prefix;
} 
 while(*out_1 != '.')
    *out_2++ = *out_1++;

if(sel == 1)
 {
  *out_2++ = *out_1;
  *out_2++ = 't';
  *out_2++ = 'x';
  *out_2++ = 't';
 }
else if(sel == 0)
 {
  *out_2++ = *out_1;
  *out_2++ = 'c';
  *out_2++ = 's';
  *out_2++ = 'v';
 }
else
 {
  *out_2++ = *out_1;
  *out_2++ = 'p';
  *out_2++ = 'n';
  *out_2++ = 'g';
 }

}

//==========================================================================================
//	make today's  parsivel file name  PARyyyymmdd.csv and PARRAWyyyymmdd.csv
//==========================================================================================
CreateParFile()
{
FILE *fpl;
char local[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char ii;
// -------------------------- Create PARyyyymmdd.csv ---------------------------------------------------
if(Parsivel.present)
 {
        OldTime.day = CurrentTime.day;
//        CreatePARlogfilename(auxlogfile,parfile); 
        CreateLogFileName("PAR",auxlogfile,local,0);
 
	strcpy(parlog,parpath);         //parpath:/home/posacq/posacq/data
	strcat(parlog,local);         //parlog:/home/posacq/posacq/data/PARyyyymmdd.csv
	printf("Today's parsivel file name is: %s\n",parlog);
	// open the file to create it
	fpl = fopen(parlog,"a");
	fclose(fpl);
	//in case we are root, change the ownership to posacq 
#if(DEBUG == 0)
	strcpy(syscmd,"chown posacq ");
	strcat(syscmd,parlog);
	printf("<%s>\n",syscmd);
	system(syscmd);	
#endif
for(ii=0;ii < 22;ii++)
   local[ii] = 0;
//=================================== Create PARRAWyyyymmdd.csv ==========================================
//        CreatePARRAWlogfilename(auxlogfile,parrawfile); 
        CreateLogFileName("PARRAW",auxlogfile,local,0);
	strcpy(parrawlog,parpath);       //parpath:home/posacq/data
	strcat(parrawlog,local);   //parrawfile:PARRAWyyyymmdd.csv
                                        //parrawlog:home/posacq/data/PARRAWyyyymmdd.csv
	printf("Today's parsivel raw  file name is: %s\n",parrawlog);
	// open the file to create it 
	fpl = fopen(parrawlog,"a");
	fclose(fpl);
	//in case we are root, change the ownership to posacq 
#if(DEBUG == 0)
	strcpy(syscmd,"chown posacq ");
	strcat(syscmd,parrawlog);
	printf("<%s>\n",syscmd);
	system(syscmd);	
#endif
for(ii=0;ii < 22;ii++)
   local[ii] = 0;
 }
if(Pos.present)
{
//----------------------------------POSyyyymmdd.txt------------------
//        CreatePOSlogfilename(auxlogfile,posfile);  
        CreateLogFileName("POS",auxlogfile,local,1);

	strcpy(poslog,parpath);         //pospath:home/posacq/data
	strcat(poslog,local);         //poslog:home/posacq/data/POSyyyymmdd.txt
	printf("Today's poss file name is: %s\n",poslog);
	// open the file to create it 
	fpl = fopen(poslog,"a");
	fclose(fpl);
	//in case we are root, change the ownership to posacq 
#if(DEBUG == 0)
	strcpy(syscmd,"chown posacq ");
	strcat(syscmd,poslog);
	printf("<%s>\n",syscmd);
	system(syscmd);	
#endif
for(ii=0;ii < 22;ii++)
   local[ii] = 0;

}
if(PWD.present)
{
//----------------------------------VISyyyymmdd.csv------------------
//        CreateVISlogfilename(auxlogfile,visfile);  
        CreateLogFileName("VIS",auxlogfile,local,0);

	strcpy(vislog,parpath);         //vispath:home/posacq/data
	strcat(vislog,local);         //vislog:home/posacq/data/VISyyyymmdd.csv
	printf("Today's vis file name is: %s\n",vislog);
	// open the file to create it 
	fpl = fopen(vislog,"a");
	fclose(fpl);
	//in case we are root, change the ownership to posacq 
#if(DEBUG == 0)
	strcpy(syscmd,"chown posacq ");
	strcat(syscmd,vislog);
	printf("<%s>\n",syscmd);
	system(syscmd);	
#endif
for(ii=0;ii < 22;ii++)
   local[ii] = 0;

}
//----------------------------------SUMyyyymmdd.csv------------------
/*
        CreateLogFileName("SUM",auxlogfile,local,0);
	strcpy(sumlog,parpath);
	strcat(sumlog,local);  //sumlog:home/posacq/data/SUMyyyymmdd.csv

	printf("Today's summary file name is: %s\n",sumlog);
	// open the file to create it 
	fpl = fopen(sumlog,"a");
	fclose(fpl);

	//in case we are root, change the ownership to posacq
#if(DEBUG == 0)
 	strcpy(syscmd,"chown posacq ");
	strcat(syscmd,sumlog);
//	printf("<%s>\n",syscmd);
	system(syscmd);	
#endif
*/
for(ii=0;ii < 22;ii++)
   local[ii] = 0;
} // end of CreateParFile

//==========================================================================================================================
CreateMainMsgFile()
{
FILE *fpl;
char local[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char ii;

//MessageFile
        CreateLogFileName("MAINLOG",auxlogfile,local,1);

	strcpy(MessageFile,parpath);
	strcat(MessageFile,local);   
	printf("Today's message   file name is: %s\n",MessageFile);
	// open the file to create it 
	fpl = fopen(MessageFile,"a");
	fprintf(fpl,"File Created:%s\n",CurrentTime.CurrDateTime);
	fclose(fpl);
	//in case we are root, change the ownership to posacq 
#if(DEBUG == 0)
	strcpy(syscmd,"chown posacq ");
	strcat(syscmd,MessageFile);
	printf("<%s>\n",syscmd);
	system(syscmd);	
#endif
//	printf("CreateMainMsgFile--ok!\n");
}
//---------------------------------------------------------------------------------------------
CreateMsgFile()
{
FILE *fpl;
char local[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char ii;
//MessageFile

if(Parsivel.present)
{
//========================== MESPARyyyymmdd.txt===========================================
        CreateLogFileName("MESPAR",auxlogfile,local,1);

	strcpy(mesparlog,parpath);
	strcat(mesparlog,local);   //mesparlog:home/posacq/data/MESPARyyyymmdd.txt
	printf("Today's message   file name is: %s\n",mesparlog);
	// open the file to create it 
	fpl = fopen(mesparlog,"a");
	fclose(fpl);
	//in case we are root, change the ownership to posacq 
#if(DEBUG == 0)
	strcpy(syscmd,"chown posacq ");
	strcat(syscmd,mesparlog);
	printf("<%s>\n",syscmd);
	system(syscmd);	
#endif
for(ii=0;ii < 22;ii++)
   local[ii] = 0;

}
if(Pos.present)
{
//========================== MESPOSyyyymmdd.txt===========================================
//	make today's poss  message  file name  MESPOSyyyymmdd.txt
        CreateLogFileName("MESPOS",auxlogfile,local,1);
	strcpy(mesposlog,parpath);
	strcat(mesposlog,local); //mesposlog: home/posacq/data/MESPOSyyyymmdd.txt
	printf("Today's message   file name is: %s\n",mesposlog);
	// open the file to create it 
	fpl = fopen(mesposlog,"a");
	fclose(fpl);
	//in case we are root, change the ownership to posacq 
#if(DEBUG == 0)

	strcpy(syscmd,"chown posacq ");
	strcat(syscmd,mesposlog);
	printf("<%s>\n",syscmd);
	system(syscmd);	
#endif
for(ii=0;ii < 22;ii++)
   local[ii] = 0;

}
//========================== MESVISyyyymmdd.txt ===========================================
//	make today's vis  message  file name  MESVISyyyymmdd.txt
if(PWD.present)
 {
        CreateLogFileName("MESVIS",auxlogfile,local,1);

	strcpy(mesvislog,parpath);
	strcat(mesvislog,local);//mesvislog: home/posacq/data/MESVISyyyymmdd.txt
	printf("Today's message   file name is: %s\n",mesvislog);
	// open the file to create it 
	fpl = fopen(mesvislog,"a");
	fclose(fpl);
	//in case we are root, change the ownership to posacq 
#if(DEBUG == 0)
	strcpy(syscmd,"chown posacq ");
	strcat(syscmd,mesvislog);
	printf("<%s>\n",syscmd);
	system(syscmd);	
#endif
for(ii=0;ii < 22;ii++)
   local[ii] = 0;

  }
} // end of mkmesnm 
//===============================================================
CreatePNGFile()
{
// ------------------- paryyyymmdd.png ----------------------------------
//	make today's  parsivel png plot file name  paryyyymmdd.png
char local[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

if(Parsivel.present)
{
        CreateLogFileName("par",auxlogfile,local,3);
	strcpy(parpnglog,parpath);
	strcat(parpnglog,local);  //parpnglog: /home/posacq/posacq/data/paryyyymmdd.png
	printf("Today's parsivel png plot file name is: %s\n",parpnglog);
}
if(Pos.present)
 {
// ------------------- posyyyymmdd.png ----------------------------------
//	make today's  poss png plot file name  posyyyymmdd.png
        CreateLogFileName("pos",auxlogfile,local,3);
	strcpy(pospnglog,parpath);
	strcat(pospnglog,local);  //pospnglog: /home/posacq/posacq/data/posyyyymmdd.png
	printf("Today's poss     png plot file name is: %s\n",pospnglog);
 }
// ------------------- visyyyymmdd.png ----------------------------------
//	make today's  vis  png plot file name  visyyyymmdd.png
if(PWD.present)
 {
        CreateLogFileName("vis",auxlogfile,local,3);
	strcpy(vispnglog,parpath);
	strcat(vispnglog,local);//vispnglog: /home/posacq/posacq/data/visyyyymmdd.png
	printf("Today's vis      png plot file name is: %s\n",vispnglog);
 }
// ------------------- sumyyymmdd.png ----------------------------------
//	make today's  summary png plot file name  sumyyyymmdd.png
        CreateLogFileName("sum",auxlogfile,local,3);
	strcpy(sumpnglog,parpath);
	strcat(sumpnglog,local);//sumpnglog: /home/posacq/posacq/data/sumyyyymmdd.png
	printf("Today's summary  png plot file name is: %s\n",sumpnglog);

        CreatepPlotDate(auxlogfile,plotdate);// plotdate - yyyy/mm/dd
} // end of mkpngnm 
//=====================================================
CreatepPlotDate(char *out_1,char *out_3) // plotdate - yyyy/mm/dd
{
  unsigned char ii;

 ii = 0;

 while(*out_1 != '.')
  {
    *out_3++ = *out_1;
    ++out_1;
    ii++;
    if((ii == 4) || (ii == 6))
       *out_3++ = '/';
    
  }
}
//===================================================================================================================
ReadParFile(int sel)
{
// sel = 0 - do not create any log files
// sel  = 1 create log files

 FILE *fppar,*fp;
 unsigned char TotalLines = 0;
 unsigned char Inputs[20][128]; 
 unsigned char *ptr,*Parptr,*ptrInput;
 unsigned char Title[128];
 unsigned char Parameter[128];
 unsigned char ii;
 unsigned char Position;
 //char line[512];
 int result,i,aux;

char xxx[60];
//char par[512];
//char value[512];
//char term[2]=" ";
//char *pdest;
//int cc,cc1;
//char temp[6];


	if((fppar = fopen(InParFileName,"rt")) == NULL)
	//if((fppar = fopen("/home/posacq/posacq/POSACQ1.PAR","rt")) == NULL)
         {
	   printf("%s\n",message_3);
            
           //Faults[PARMIN] += 1;
           //Faults[PARDAY] += 1;
           //Faults[POSMIN] += 1;
           //Faults[POSDAY] += 1;
           //Faults[AUXDAY] += 1;

           Faults[PARFILEOPEN] += 1;	

	   fp=fopen(MessageFile,"a");
	   fprintf(fp,"%s, parameter file POSACQ1.PAR was not found, will use defaults\n",CurrentTime.timeonly);
	   fclose(fp);

    if(sel == 1)
      {
         if(Parsivel.present)
         {
	   fp=fopen(mesparlog,"a");
	   fprintf(fp,"%i,%s parameter file SERACQ1.PAR was not found, will use defaults\n",Faults[PARFILEOPEN],CurrentTime.CurrDateTime);
	   fclose(fp);
         }
         if(Pos.present)
          {
	   fp=fopen(mesposlog,"a");
	   fprintf(fp,"%i,%s parameter file SERACQ1.PAR was not found, will use defaults\n",Faults[PARFILEOPEN],CurrentTime.CurrDateTime);
	   fclose(fp);
          }
        if(PWD.present)
         {
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s parameter file SERACQ1.PAR was not found, will use defaults\n",Faults[PARFILEOPEN],CurrentTime.CurrDateTime);
	   fclose(fp);
        }
      }
   return(0);
  }
//=======================================================================
     else
      {
        while(!feof(fppar))
        {
      // do{
           fgets(Inputs[TotalLines],sizeof(Inputs[TotalLines]),fppar);

	   if(sel == 1)
            {
             printf("%s",Inputs[TotalLines]);	

             strcpy(xxx,Inputs[TotalLines]);

	     fp=fopen(MessageFile,"a");
             fprintf(fp,"%s,%s",CurrentTime.timeonly,Inputs[TotalLines]);
	     fclose(fp);

            if(Parsivel.present)
               {
                fp=fopen(mesparlog,"a");
		fprintf(fp,"%i,%s %s",Faults[PARDAY],CurrentTime.CurrDateTime,Inputs[TotalLines]);
		fclose(fp);
              }
             if(Pos.present)
              {
		fp=fopen(mesposlog,"a");
		fprintf(fp,"%i,%s %s",Faults[POSDAY],CurrentTime.CurrDateTime,Inputs[TotalLines]);
		fclose(fp);
              }
            if(PWD.present)
              {

		fp=fopen(mesvislog,"a");
		fprintf(fp,"%i,%s %s",Faults[VISDAY],CurrentTime.CurrDateTime,Inputs[TotalLines]);
		fclose(fp);
              }
            } //end if sel

               TotalLines++;

         }//while(!feof(fppar));

    fclose(fppar);
  }  
//=======================================================================
for (ii = 0; ii < PARFILELINES;ii++)
 {
   ptrInput = Inputs[ii];
   ptr = Title;
   Parptr = Parameter;

   if(strncmp(Inputs[ii], "/", 1) !=0 )
    {
      Position = strcspn(Inputs[ii],"="); // get position of '='
      if(Position > 2)
       {
          strncpy(ptr,Inputs[ii],(Position-1));   //copy left side of '=' to ptr
          sscanf(ptrInput +=(Position+1),"%s",Parptr); // copy right side of '=' to Parptr

          switch (ii)
             {
               case 0:
                 if(strncmp("POSACQ1.PAR",ptr,10) == 0)   //Date
                  {                     
                         //sscanf(Parptr,"%s",pardate);
                         strcpy(pardate,Parptr);
                      if(sel == 1)
                         printf("Version: %s",pardate);
                   }
               break;

               case 1:
                 if(strncmp("site",ptr,3) == 0)   // Site
	          {    
                         //sscanf(Parptr,"%s",site);
                         strcpy(site,Parptr);
                      if(sel == 1)
                         printf("\nSite: %s",site);
                   }
               break;

              case 2:
                 if(strncmp("maildest",ptr,6) == 0)   // Site
                   {
	              sscanf(Parptr,"%s",maildest);
	      // replace ';' with ' ' in multiple email destinations 
	             result = strlen(maildest);
	             for(i=0; i<result; i++)
                     {
	                 if(maildest[i]==';') 
                         maildest[i]=' ';
	             }
                      if(sel == 1)
                         printf("\nMail: %s",maildest);
	         }
               break;
/*
              case 3:
                 if(strncmp("hotsendmail",ptr,7) == 0)   // Site
           	  {
//                         sscanf(Parptr,"%i",&Hot.sendmail);
                         myatoi(Parptr,&aux);
                         Hot.sendmail = aux;
                      if(sel == 1)
                         printf("\nHotSendMail: %i",Hot.sendmail);
	          }

              break;

              case 4:
                 if(strncmp("parsendmail",ptr,8) == 0)   // Site
             	  { 
//                    sscanf(Parptr,"%i",&Parsivel.sendmail);
                    myatoi(Parptr,&aux);
                    Parsivel.sendmail = aux;
                    if(sel == 1)
                    printf("\nParsSendMail: %i",Parsivel.sendmail);
	          }

              break;
*/
              case 3:
                 if(strncmp("possendmail",ptr,8) == 0)   //Bat Voltage
             	 { 
                         myatoi(Parptr,&aux);
                         Pos.sendmail = aux;
                  //sscanf(Parptr,"%i",&Pos.sendmail);
                      if(sel == 1)
                         printf("\nPossSendMail: %i",Pos.sendmail);
	          }

              break;
/*
              case 6:
                 if(strncmp("vissendmail",ptr,8) == 0)   //Crtemp
                 {
//                      	 sscanf(Parptr,"%i",&PWD.sendmail); 
                         myatoi(Parptr,&aux);
                         PWD.sendmail = aux;
                      if(sel == 1)
                         printf("\nVisSendMail: %i",PWD.sendmail);
	          }

              break;
*/
              case 4:
                 if(strncmp("auxsendmail",ptr,8) == 0)   //Crtemp
                 {
//                      	 sscanf(Parptr,"%i",&PWD.sendmail); 
                         myatoi(Parptr,&aux);
                         AuxDevice.sendmail = aux;
                      if(sel == 1)
                         printf("\nAuxSendMail: %i",AuxDevice.sendmail);
	          }

              break;

/*
              case 8:
                 if(strncmp("parscom",ptr,6) == 0)   
                 {    
             	   //sscanf(Parptr,"%s",Parsivel.comstring); 
                   strcpy(Parsivel.comstring,Parptr);
                      if(sel == 1)
                   printf("\nParsInput: %s",Parsivel.comstring);
	          }

              break;
*/
              case 5:
                 if(strncmp("poscom",ptr,4) == 0)   
                  { 
//             	   sscanf(Parptr,"%s",Pos.comstring); 
                   strcpy(Pos.comstring,Parptr);
                      if(sel == 1)
                   printf("\nPossInput: %s",Pos.comstring);
	          }
              break;
/*
              case 10:
                 if(strncmp("viscom",ptr,4) == 0)   
                { 
//             	   sscanf(Parptr,"%s",PWD.comstring); 
                   strcpy(PWD.comstring,Parptr);
                      if(sel == 1)
                   printf("\nVisInput: %s",PWD.comstring);
	          }

              break;
*/
              case 6:
                 if(strncmp("auxcom",ptr,4) == 0)   
                { 
//             	   sscanf(Parptr,"%s",PWD.comstring); 
                   strcpy(AuxDevice.comstring,Parptr);
                      if(sel == 1)
                   printf("\nAuxInput: %s",AuxDevice.comstring);
	          }

              break;


              case 7:
                 if(strncmp("pospre",ptr,6) == 0)
                   {   
             	     //sscanf(Parptr,"%i",&Pos.present);
                      myatoi(Parptr,&aux);
                      Pos.present = aux;
                      if(sel == 1)
                      printf("\nPosPresent: %i",Pos.present);
                    } 
              break;
/*
              case 13:
                 if(strncmp("vispre",ptr,6) == 0)
                  {  
             	     //sscanf(Parptr,"%i",&PWD.present); 
                      myatoi(Parptr,&aux);
                      PWD.present = aux; 
                      if(sel == 1)
                      printf("\nVisPresent: %i",PWD.present);
                    } 
              break;

              case 14:
                 if(strncmp("parsivalpre",ptr,11) == 0) 
                  {
             	     //sscanf(Parptr,"%i",&Parsivel.present); 
                      myatoi(Parptr,&aux);
                      Parsivel.present = aux;
                      if(sel == 1)
                       printf("\nPrsPresent: %i",Parsivel.present);
                    } 
                    //else
                    //  printf("\n");
              break;
*/
              case 8:
                 if(strncmp("auxdevpresent",ptr,11) == 0) 
                  {
             	     //sscanf(Parptr,"%i",&Parsivel.present); 
                      myatoi(Parptr,&aux);
                      AuxDevice.present = aux;
                      if(sel == 1)
                       printf("\nAuxDevicePresent: %i",AuxDevice.present);
                    } 
              break;

              case 9:
                 if(strncmp("path",ptr,3) == 0)   // Site
                   {
	              sscanf(Parptr,"%s",mainpath);
                      if(sel == 1)
                         printf("\nFilePath: %s\n",mainpath);
	         }
                    else                  // this should always be moved to last 'case'
                      printf("\n");

               break;


/*
              case 10:
                 if(strncmp("XMITP",ptr,5) == 0)   // XMITPOWER_thresh
             	   sscanf(Parptr,"%f",&XMITPOWER_thresh); 
              break;

              case 11:
                 if(strncmp("MagHours",ptr,6) == 0)   // XMITPOWER_thresh
             	   sscanf(Parptr,"%f",&MagHours); 
              break;
 */
           default:
	    printf("%s",message_2);
	    // write to message files 
	    // this is not normal, so increment the Faults[HOTMIN] etc counters 
	    //Faults[HOTMIN] += 1;
            //Faults[HOTDAY] += 1;
            //Faults[PARMIN] += 1;
            //Faults[PARDAY] += 1;
	    //Faults[POSMIN] += 1;
	    //Faults[POSDAY] += 1;
            //Faults[VISMIN] += 1;
            //Faults[VISDAY] += 1;
            //Faults[AUXMIN] += 1;
            //Faults[AUXDAY] += 1;

           Faults[PARFILEERR] += 1;	

	   fp=fopen(MessageFile,"a");
	   fprintf(fp,"%s, unknown parameter in Par File\n",CurrentTime.timeonly);
	   fclose(fp);

          if(sel == 1)
          {
	   
          if(Parsivel.present)
           {  
	    fp=fopen(mesparlog,"a");
	    fprintf(fp,"%i,%s unknown parameter\n",Faults[PARFILEERR],CurrentTime.CurrDateTime);
	    fclose(fp);
           }
          if(Pos.present)
           {  
	    fp=fopen(mesposlog,"a");
	    fprintf(fp,"%i,%s unknown parameter\n",Faults[PARFILEERR],CurrentTime.CurrDateTime);
	    fclose(fp);
           }
          if(PWD.present)
           {  
	    fp=fopen(mesvislog,"a");
	    fprintf(fp,"%i,%s unknown parameter\n",Faults[PARFILEERR],CurrentTime.CurrDateTime);
	    fclose(fp);
          }
       } // end if sel == 1
       break;
      } //end of switch

    for (Position = 0; Position < 128;Position++)
      {
          Title[Position] = 0;
          Parameter[Position] = 0;
       }
     }//end if(Position > 2)
   } // end  if(strncmp(Inputs[ii], "/", 1) !=0 )
 } //end of for
//=======================================================================
 if(sel == 1)
  {	
           fp=fopen(MessageFile,"a");
	   fprintf(fp,"\n%s, Par File Summary: Version: %s, Site: %s\n",CurrentTime.timeonly,pardate,site);
	   fprintf(fp,"MailDestination: %s\n",maildest);
	   fprintf(fp,"Send Mail Status: %i,%i\n",Pos.sendmail,AuxDevice.sendmail);
	   fprintf(fp,"Inputs:Pos: %s,AUX: %s\n",Pos.comstring,AuxDevice.comstring);
	   fprintf(fp,"Devices:Pos: %i,Aux: %i\n",Pos.present,AuxDevice.present);
	   fprintf(fp,"Path: %s\n",mainpath);
	   fclose(fp);
  }
} // end of readparfile() 

//=============================================================================
ExtractKeyboard(char *ptr)
 {
   char temp[81];
   char i;
   FILE *fp;

     printf("\ngot word %s\n",ptr);  
     
     if(memcmp(ptr,"help",4)==0)
        {
           //printf("\n");
	   printf("\nhelp	  - list keyboard commands\n");

           //printf("dailyplot - create daily plots now\n");
	   printf("comment   - add an operator comment to START.LOG\n");
//----------------------------------------------------------------------------        
           printf("loadpar   - Load parametar file\n");
	   printf("mail      - Send Test emcheckparsivelsbail\n");
           printf("ver	  - Get Software Version\n");             
	   printf("quit      - exit program\n");

 	   
 	   if(Parsivel.present)
             {	
                printf("pardon   - print all parsivel status lines\n");
		printf("parreset - reset the parsivel sensor accumulations\n");
		printf("paroutconf  - output the parsivel configuration\n");
		printf("parsettele  - set the parsivel telegram\n");
		printf("parsettime  - set the par time to the PC time\n");
		printf("parcommand  - send a command to parsivel\n");
             }
 	   if(Pos.present)
             {	
		printf("posdon    - print all poss status lines\n");
		printf("posdoff   - do not print poss status lines\n");
		printf("posrawdon - print all poss raw characters\n");
             }
 	   if(PWD.present)
             {
		printf("visdon   - print all vis status lines\n");
		printf("visreset - reset the vis sensor accumulations\n");
		printf("vistime  - display the vis time\n");
		printf("vissettime  - set the vis time to the PC time\n");
		printf("visames  - set the vis message & interval to 2 60\n");
             }
         }// end of help

    else if(memcmp(ptr,"loadpar",7)==0)
      {
       fp=fopen(MessageFile,"a");
       fprintf(fp,"%s got command:loadpar\n",CurrentTime.timeonly);
       fclose(fp);
       ReadParFile(1);
       printf("\nNote:If Communication Port settings are changed (xxxcom section),\n");
       printf("POSACQ software needs to be restarted for change to take effect\n");
      } 

    else if(memcmp(ptr,"mail",4)==0)
      {
       fp=fopen(MessageFile,"a");
       fprintf(fp,"%s got command:mail\n",CurrentTime.timeonly);
       fclose(fp);

       summaryemail(" -stestsummary");
      } 
/*   
else if(memcmp(ptr,"dailyplot",9)==0)
      {
//       fp=fopen(mesvprlog,"a");
//       fprintf(fp,"%s got command:dailyplot\n",CurrentTime.timeonly);
//       fclose(fp);
         dailyplots();
      }
*/
   else if(memcmp(ptr,"ver",3)==0)
	printf("Software Version: %s\n",VERDATE); 

   else if(memcmp(ptr,"quit",4)==0)
        {
	 fp=fopen(MessageFile,"a");
	 fprintf(fp,"%s keyboard quit command\n",CurrentTime.timeonly);
	 fclose(fp);

          
        if(Parsivel.present)
        {
	 fp=fopen(mesparlog,"a");
	 fprintf(fp,"%i,%s keyboard quit command\n",Faults[PARDAY],CurrentTime.CurrDateTime);
	 fclose(fp);
        }
        if(Pos.present)
        {
	 fp=fopen(mesposlog,"a");
	 fprintf(fp,"%i,%s keyboard quit command\n",Faults[POSDAY],CurrentTime.CurrDateTime);
	 fclose(fp);
        }
        if(PWD.present)
        {
	 fp=fopen(mesvislog,"a");
	 fprintf(fp,"%i,%s keyboard quit command\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	 fclose(fp);
       }
	 exit(0);
   } //end of quit
    else if(memcmp(ptr,"comment",7)==0)
     {
	 memccpy(temp,(ptr+=7),'\n',72);	// get comment, on same line, max 72 chars 

	 fp=fopen(MessageFile,"a");
	 fprintf(fp,"%s comment: <%s>\n",CurrentTime.timeonly,temp);
	 fclose(fp);

	
        if(Parsivel.present)
        {
	 fp=fopen(mesparlog,"a");
	 fprintf(fp,"%i,%s comment: <%s>\n",Faults[PARDAY],CurrentTime.CurrDateTime,temp);
	 fclose(fp);
        }
        if(Pos.present)
        {
	 fp=fopen(mesposlog,"a");
	 fprintf(fp,"%i,%s comment: <%s>\n",Faults[POSDAY],CurrentTime.CurrDateTime,temp);
	 fclose(fp);
        }
        if(PWD.present)
        {
	 fp=fopen(mesvislog,"a");
	 fprintf(fp,"%i,%s comment: <%s>\n",Faults[VISDAY],CurrentTime.CurrDateTime,temp);
	 fclose(fp);
        }
     }
// ----------------------------------------------------------------
   //else if
   // {
    else if(*ptr)
     { 
      if(Pos.present)
	{
          fp=fopen(MessageFile,"a");
          fprintf(fp,"%s got command: %s\n",CurrentTime.timeonly,ptr);
          fclose(fp);

	 if(memcmp(ptr,"posdon", 6) == 0) 
           Pos.dumpline = 1;//posd=1;
	 else if(memcmp(ptr,"posdoff",7) == 0) 
          Pos.dumpline = 0;//posd=0;
	 else if(memcmp(ptr,"posrawdon",  9) == 0) 
           posrawd = 1;
	 else if(memcmp(ptr,"posrawdoff",10) == 0) 
           posrawd = 0;
	}
      
      if(Parsivel.present)
 	{
          fp=fopen(MessageFile,"a");
          fprintf(fp,"%s got command: %s\n",CurrentTime.timeonly,ptr);
          fclose(fp);

	if(memcmp(ptr,"pardon", 6)==0) 
          Parsivel.dumpline = 1;//pard=1;
	else if(memcmp(ptr,"pardoff",7)==0) 
           Parsivel.dumpline = 0;//pard=0;
	else if(memcmp(ptr,"parreset",8)==0)
           resetpar();
	else if(memcmp(ptr,"paroutconf",10)==0) 
           paroutconf();
	else if(memcmp(ptr,"parsettele",10)==0) 
              parsettele();
	else if(memcmp(ptr,"parsettime",10)==0) 
          parsettime();
	else if(memcmp(ptr,"parcommand",10)==0)
          {
	        for(i=0; i<80; i++)
                    parcmd[i]='\0';

	        memccpy(parcmd,&kbword[11],'\n',72);	// get the command, on same line, max 72 chars 
	        parcommand();
           }
  	}
   if(PWD.present)
   {
          fp=fopen(MessageFile,"a");
          fprintf(fp,"%s got command: %s\n",CurrentTime.timeonly,ptr);
          fclose(fp);

	if(memcmp(ptr,"visreset",8)==0) visreset();
	else if(memcmp(ptr,"vistime",7)==0) vistime();
	else if(memcmp(ptr,"vissettime",10) == 0) vissettime();
	else if(memcmp(ptr,"visames",7)==0) visames();
	else if(memcmp(ptr,"visdon", 6)==0) PWD.dumpline = 1;//visd=1;
	else if(memcmp(ptr,"visdoff",7)==0) PWD.dumpline = 0;//visd=0;
   }
}
// ----------------------------------------------------------------
    else 
      {
       printf("Not a valid command word.\n");
       fp=fopen(MessageFile,"a");
       fprintf(fp,"%s not valid command\n",CurrentTime.timeonly);
       fclose(fp);

      }

	// clear out kbword 
    for(i = 0;i < 80;i++) 
        *ptr++ = 0;

      kbptr=0;
 } // end of ExtractKeyboard()
//============================================================================
checkkybd_1()
{
//int nh;
int nread;
char ch;

// read keyboard until we have no more keyboard hits 
 do
  {
	nread = read(0,&ch,1);

	if(nread == 1)
         {	// we've read a character 
	   if(kbptr > 80)
               kbptr = 0;  // expect cr within 80 chars
	   if(ch == 0x03) 
             exit(0);  // quit on ctrl-c 

	   kbchar = tolower(ch);
	   kbword[kbptr++] = kbchar;

	   if(kbchar == 0x0A) 
             {    // process a word 
                FlagKeyboardMsg = 1;   
	        kbword[kbptr] = 0;    // append a NULL
                nread = 0;
             }
      } // end of read a character 
    } while(nread > 0);// end of do 
}
//==========================================================================================================
resetpar()
{
// the string <CS/Z/1cr> will restart the parsivel sensor and zero the rain accumulation 

char cmd[8]="CS/Z/1";
int nchar;
FILE *fp;

	cmd[6]=0x0D;	// append the cr 
	nchar = write(Parsivel.ComPort,&cmd,7); // send the command 

	if(nchar==-1)
         {
	   Faults[PARMIN] += 1;
           Faults[PARDAY] += 1;
	   printf("resetpar() write failed,PARTotalErr: %i\n",Faults[PARDAY]);
	   fp=fopen(mesparlog,"a");	   // write to message file 
	   fprintf(fp,"%i,%s resetpar() write failed\n",Faults[PARDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,ParsDayFaults: %i,resetpar() write failed\n",CurrentTime.timeonly,Faults[PARDAY]);
	   fclose(fp);

	}
	else
        {
	   Faults[PARMIN] +=1;
           Faults[PARDAY] +=1;
	   printf("%s resetpar() wrote %i chars <%.7s>,PARTotalErr: %i\n",CurrentTime.CurrDateTime,nchar,cmd,Faults[PARDAY]);
	   // write to message file 
	   fp=fopen(mesparlog,"a");
	   fprintf(fp,"%i,%s resetpar() wrote %i chars <%.7s>\n",Faults[PARDAY],CurrentTime.CurrDateTime,nchar,cmd);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,ParsDayFaults: %i,resetpar() wrote %i chars <%.7s>\n",CurrentTime.timeonly,Faults[PARDAY],nchar,cmd);
	   fclose(fp);

	}
} // end of resetpar() 
//===================================================================================================
paroutconf()
{
// the string CS/L will output the current configuration 

char cmd[6]="CS/L ";
int nchar;
FILE *fp;

	cmd[4]=0x0D;	// append the cr 
	nchar=write(Parsivel.ComPort,&cmd,5); // send the command 

	if(nchar == -1)
         {
	   Faults[PARMIN] += 1;
           Faults[PARDAY] += 1;
	   printf("paroutconf() write failed, PARTotalErr: %i\n",Faults[PARDAY]);
	   fp=fopen(mesparlog,"a");	   // write to message file 
	   fprintf(fp,"%i,%s paroutconf() write failed\n",Faults[PARDAY],CurrentTime.CurrDateTime);
	   fclose(fp);
	}
	else
         {
	   Faults[PARMIN]++;Faults[PARDAY]++;
	   printf("paroutconf() wrote %i chars <%.7s>,PARTotalErr: %i\n",nchar,cmd,Faults[PARDAY]);
	   fp=fopen(mesparlog,"a");	   // write to message file 
	   fprintf(fp,"%i,%s paroutconf() wrote %i chars <%.7s>\n",Faults[PARDAY],CurrentTime.CurrDateTime,nchar,cmd);
	   fclose(fp);
	}
} // end of paroutconf() 
// =========================================================================================
parsettele()
{
// set a new user telegram  
int nchar;
//char cmd1[9]="CS/M/S/c";
//char cmd2[82]="%22,%21,%20,%18,%25,%01,%02,%03,%04,%05,%06,%07,%08,%11,%10,%12,%16,%17,%93,/r/nc";
//char cmd3[10]="CS/M/M/0c";	// select the user telegram 

char cmd1[9]="CS/M/S/\r";
char cmd2[82]="%22,%21,%20,%18,%25,%01,%02,%03,%04,%05,%06,%07,%08,%11,%10,%12,%16,%17,%93,/r/n\r";
char cmd3[10]="CS/M/M/0\r";	// select the user telegram 

FILE *fp;

	//cmd1[7]=0x0D;	// insert the cr 
	//cmd2[80]=0x0D;	// insert the cr 
	//cmd3[8]=0x0D;	// insert the cr 

	nchar = write(Parsivel.ComPort,&cmd1,8); // send the command 

	if(nchar==-1)
         {
	   Faults[PARMIN] += 1;
           Faults[PARDAY] += 1;
	   printf("%i,parsettele() write failed\n",Faults[PARDAY]);
	   // write to message file 
	   fp=fopen(mesparlog,"a");
	   fprintf(fp,"%i,%s parsettele() write failed\n",Faults[PARDAY],CurrentTime.CurrDateTime);
	   fclose(fp);
	}
	else{
	   Faults[PARMIN] += 1;
           Faults[PARDAY] += 1;
	   printf("%i,%s parsettele() wrote %i chars <%.8s>\n",Faults[PARDAY],CurrentTime.CurrDateTime,nchar,cmd1);
	   // write to message file 
	   fp=fopen(mesparlog,"a");
	   fprintf(fp,"%i,%s parsettele() wrote %i chars <%.8s>\n",Faults[PARDAY],CurrentTime.CurrDateTime,nchar,cmd1);
	   fclose(fp);
	}

	usleep(125000);	// we need a delay between the two lines 
	nchar=write(Parsivel.ComPort,&cmd2,81); // send the command 

	if(nchar==-1)
           {
	   Faults[PARMIN] += 1 ;
           Faults[PARDAY] += 1;
	   printf("%i,parsettele() write failed\n",Faults[PARDAY]);
	   // write to message file 
	   fp=fopen(mesparlog,"a");
	   fprintf(fp,"%i,%s parsettele() write failed\n",Faults[PARDAY],CurrentTime.CurrDateTime);
	   fclose(fp);
	}
	else{
	   Faults[PARMIN] += 1;
           Faults[PARDAY] +=1 ;
	   printf("%i,parsettele() wrote %i chars <%.80s>\n",Faults[PARDAY],nchar,cmd2);
	   // write to message file 
	   fp=fopen(mesparlog,"a");
	   fprintf(fp,"%i, parsettele() wrote %i chars <%.80s>\n",Faults[PARDAY],nchar,cmd2);
	   fclose(fp);
	}


} // end of parsettele() 
// ==================================================================================================
parsettime()
{
char cmd[26] = "CS/T/";  //"CS/T/hh:mm:ssc";
//char cmd[26] = "CS/T/hh:mm:ssc";
int nchar;
FILE *fp;
         
        strcat(cmd,CurrentTime.timeonly);
        strcat(cmd,"\r");
	//cmd[14]=0x00;	// insert a null 
/*
	cmd[ 5]=scurdatetim[11]; // hh 
	cmd[ 6]=scurdatetim[12];
	cmd[ 8]=scurdatetim[14]; // mm 
	cmd[ 9]=scurdatetim[15];
	cmd[11]=scurdatetim[17]; // ss 
	cmd[12]=scurdatetim[18];
	cmd[13]=0x0D;	// insert the cr 
	cmd[14]=0x00;	// insert a null 
*/
	nchar = write(Parsivel.ComPort,&cmd,14); // send the command 

	if(nchar == -1)
          {
	   Faults[PARMIN] += 1;
           Faults[PARDAY] += 1;
	   printf("%i,parsettime() write failed\n",Faults[PARDAY]);
	   fp=fopen(mesparlog,"a");	   // write to message file 
	   fprintf(fp,"%i,%s parsettime() write failed\n",Faults[PARDAY],CurrentTime.CurrDateTime);
	   fclose(fp);
	 }
	else
         {
	   Faults[PARMIN] += 1;
           Faults[PARDAY] += 1;
	   printf("<%.13s> %i,%s parsettime() wrote %i chars\n",cmd,Faults[PARDAY],CurrentTime.CurrDateTime,nchar);
	   fp=fopen(mesparlog,"a");	   // write to message file 
	   fprintf(fp,"<%.13s> %i,%s parsettime() wrote %i chars\n",cmd,Faults[PARDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);
	}
} // end of parsettime() 
// ==========================================================================================
visreset()
{
//  clear the accumulations,dump status 
//char cmd[21]="OPEN\rCLRS\rSTA\rCLOSEc\r";
char cmd1[6]="OPEN\r";
char cmd2[6]="CLRS\r";
char cmd3[5]="STA\r";
char cmd4[7]="CLOSE\r";
int nchar;
FILE *fp;

	//cmd1[4]=0x0D;	// insert the cr 
	//cmd2[4]=0x0D;	// insert the cr 
	//cmd3[3]=0x0D;	// insert the cr 
	//cmd4[5]=0x0D;	// insert the cr 

	nchar = write(PWD.ComPort,&cmd1,5); // send the open command 

	if(nchar==-1)
         {
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,visreset() write failed\n",Faults[VISDAY]);
	   /* write to message file */
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s visreset() write failed\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");
	   fprintf(fp,"%s,VISDayFaults: %i, visreset() write failed\n",CurrentTime.timeonly,Faults[VISDAY]);
	   fclose(fp);

	}
	else{
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("<%s> %i,visreset() wrote %i chars\n",cmd1,Faults[VISDAY],nchar);
	   fp=fopen(mesvislog,"a");	   // write to message file 
	   fprintf(fp,"<%s> %i,%s visreset() wrote %i chars\n",cmd1,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");
	   fprintf(fp,"%s,VISDayFaults: %i, <%s> visreset() wrote %i chars\\n",CurrentTime.timeonly,Faults[VISDAY],cmd1,nchar);
	   fclose(fp);

	}

	usleep(250000);	// need a delay here 
	nchar=write(PWD.ComPort,&cmd2,5); //send the clrs command 

	if(nchar==-1)
         {
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,visreset() write failed\n",Faults[VISDAY]);
	   fp=fopen(mesvislog,"a");	   // write to message file 
	   fprintf(fp,"%i,%s visreset() write failed\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, visreset() write failed\n",CurrentTime.timeonly,Faults[VISDAY]);
	   fclose(fp);

	}
	else{
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("<%s> %i,visreset() wrote %i chars\n",cmd2,Faults[VISDAY],nchar);
	   fp=fopen(mesvislog,"a");	   // write to message file 
	   fprintf(fp,"<%s> %i,%s visreset() wrote %i chars\n",cmd2,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, <%s> visreset() wrote %i chars\n",CurrentTime.timeonly,Faults[VISDAY],cmd2,nchar);
	   fclose(fp);

	}

	usleep(250000);	// need a delay here 
	nchar=write(PWD.ComPort,&cmd3,4); // send the sta command 

	if(nchar==-1)
         {
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,visreset() write failed\n",Faults[VISDAY]);
	   fp=fopen(mesvislog,"a");	   // write to message file 
	   fprintf(fp,"%i,%s visreset() write failed\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, visreset() write failed\n",CurrentTime.timeonly,Faults[VISDAY]);
	   fclose(fp);

	}
	else{
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("<%s> %i,visreset() wrote %i chars\n",cmd3,Faults[VISDAY],nchar);
	   fp=fopen(mesvislog,"a");	   // write to message file 
	   fprintf(fp,"<%s> %i,%s visreset() wrote %i chars\n",cmd3,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, <%s> visreset() wrote %i chars\n",CurrentTime.timeonly,Faults[VISDAY],cmd3,nchar);
	   fclose(fp);

	}

	usleep(250000);	// need a delay here 
	nchar=write(PWD.ComPort,&cmd4,6); // send the close command 

	if(nchar==-1)
         {
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,visreset() write failed\n",Faults[VISDAY]);
	   fp=fopen(mesvislog,"a");	   // write to message file
	   fprintf(fp,"%i,%s visreset() write failed\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, visreset() write failed\n",CurrentTime.timeonly,Faults[VISDAY]);
	   fclose(fp);
	}
	else{
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("<%s> %i,visreset() wrote %i chars\n",cmd4,Faults[VISDAY],nchar);
	   fp=fopen(mesvislog,"a");	   // write to message file 
	   fprintf(fp,"<%s> %i,%s visreset() wrote %i chars\n",cmd4,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, <%s> visreset() wrote %i chars\n",CurrentTime.timeonly,Faults[VISDAY],cmd4,nchar);
	   fclose(fp);
	}
} // end of visreset() 
// ==============================================================================================================
vistime()
{
// display vis time 

//char cmd[17]="OPENcTIMEcCLOSEc";
char cmd1[6]="OPEN\r";
char cmd2[6]="TIME\r";
char cmd3[7]="CLOSE\r";
int nchar;
FILE *fp;

	//cmd1[4]=0x0D;	// insert the cr
	//cmd2[4]=0x0D;	// insert the cr
	//cmd3[5]=0x0D;	// insert the cr

	nchar=write(PWD.ComPort,&cmd1,5); // send the open command 

	if(nchar==-1)
        {
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,vistime() write failed\n",Faults[VISDAY]);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s vistime() write failed\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, vistime() write failed\n",CurrentTime.timeonly,Faults[VISDAY]);
	   fclose(fp);
	}
	else{
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("<%s> %i,%s vistime() wrote %i chars\n",cmd1,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"<%s> %i,%s vistime() wrote %i chars\n",cmd1,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, <%s> vistime() wrote %i chars\n",CurrentTime.timeonly,Faults[VISDAY],cmd1,nchar);
	   fclose(fp);

	}

	usleep(250000);	// we need a delay here 
	nchar=write(PWD.ComPort,&cmd2,5); // send the time command 

	if(nchar==-1){
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,vistime() write failed\n",Faults[VISDAY]);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s vistime() write failed\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, vistime() write failed\n",CurrentTime.timeonly,Faults[VISDAY]);
	   fclose(fp);

	}
	else{
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("<%s> %i,%s vistime() wrote %i chars\n",cmd2,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"<%s> %i,%s vistime() wrote %i chars\n",cmd2,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, <%s> vistime() wrote %i chars\n",CurrentTime.timeonly,Faults[VISDAY],cmd2,nchar);
	   fclose(fp);

	}

	usleep(250000);	// we need a delay here 
	nchar=write(PWD.ComPort,&cmd3,6); // send the close command

	if(nchar==-1){
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,vistime() write failed\n",Faults[VISDAY]);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s vistime() write failed\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, vistime() write failed\n",CurrentTime.timeonly,Faults[VISDAY]);
	   fclose(fp);

	}
	else{
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("<%s> %i,%s vistime() wrote %i chars\n",cmd3,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"<%s> %i,%s vistime() wrote %i chars\n",cmd3,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, <%s> vistime() wrote %i chars\n",CurrentTime.timeonly,Faults[VISDAY],cmd3,nchar);
	   fclose(fp);

	}
} // end of vistime()
// ===================================================================================================
vissettime()
{
// set vis time/
//char cmd[26]="OPENcTIME hh mm sscCLOSEc";
char cmd[26]="OPEN\rTIME ";
int nchar;
char *ptr;
char aux[9];
FILE *fp;

strcpy(aux,CurrentTime.timeonly);

ptr = aux;

while(*ptr)
 {
  if((*ptr) == ':')
   *ptr = ' ';

  ptr++;
}
        strcat(cmd,aux);
        strcat(cmd,"\rCLOSE\r");


	//cmd[4]=0x0D;	// insert the cr /
	//cmd[10]=scurdatetim[11];	 // hh 
	//cmd[11]=scurdatetim[12];
	//cmd[13]=scurdatetim[14]; // mm 
	//cmd[14]=scurdatetim[15];
	//cmd[16]=scurdatetim[17]; // ss 
	//cmd[17]=scurdatetim[18];
	//cmd[18]=0x0D;	// insert the cr 
	//cmd[24]=0x0D;	// insert the cr 
	
      nchar=write(PWD.ComPort,&cmd,25); // send the command 

	if(nchar==-1){
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,vissettime() write failed\n",Faults[VISDAY]);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s vissettime() write failed\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, vissettime() write failed\n",CurrentTime.timeonly,Faults[VISDAY]);
	   fclose(fp);

	}
	else{
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("<%s> %i,vissettime() wrote %i chars\n",cmd,Faults[VISDAY],nchar);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"<%s> %i,%s vissettime() wrote %i chars\n",cmd,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, <%s> vissettime() wrote %i chars\n",CurrentTime.timeonly,Faults[VISDAY],cmd,nchar);
	   fclose(fp);

	}
} // end of vissettime() 

// =============================================================================================
visames()
{
// set vis message and interval (and delay by about 10 secs) 

char cmd[22]="OPEN\rAMES 2 60\rCLOSE\r";
int nchar;
FILE *fp;

	//cmd[4]=0x0D;	// insert the cr 
	//cmd[14]=0x0D;	// insert the cr 
	//cmd[20]=0x0D;	// insert the cr 
	
       nchar=write(PWD.ComPort,&cmd,21); //send the command

	if(nchar==-1){
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,visames() write failed\n",Faults[VISDAY]);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s visames() write failed\n",Faults[VISDAY],CurrentTime.CurrDateTime);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, visames() write failed\n",CurrentTime.timeonly,Faults[VISDAY]);
	   fclose(fp);

	}
	else{
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("<%s> %i,%s visames() wrote %i chars\n",cmd,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"<%s> %i,%s visames() wrote %i chars\n",cmd,Faults[VISDAY],CurrentTime.CurrDateTime,nchar);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,VISDayFaults: %i, <%s> visames() wrote %i chars\n",CurrentTime.timeonly,Faults[VISDAY],cmd,nchar);
	   fclose(fp);

	}
} // end of visames() 
// ======================================================================================
GetPossSerialData()
{
char RxSingle; 
//char2;
	/* data is 9600, 7,E,1, 1 minute, variable length, between SOH and EOT 
	 packets start with 0D 0A 01  (CR LF SOH)
	 packets end with   0A 0D 04  (LF CR EOT)

	 then we get an optional histogram
	  packets start with 02 (STX)
	  packets end with 0D 0A 04 0A 0D 00 (CR LF EOT LF CR NULL) */

	// the poss output messages cannot by syncd to the PC clock. 
	
	   
	// read 1 char at a time until we have a packet (ends in EOT 0x04), or no more char

	do {
   	   Pos.ReadChCount = read(Pos.ComPort,&RxSingle,1);

	   if(Pos.ReadChCount < 0)
                perror("read failed");
           if(Pos.ReadChCount == 1) 
            {
	     if(posrawd == 1) 
              {
                   printf("posrawd Pos.RxCharIndex=%i char2 %2.2X <%c>",Pos.RxCharIndex,RxSingle,RxSingle);

	         if (RxSingle == 0x01)
                    printf(" SOH\n");
	        else if(RxSingle == 0x02)
                    printf(" STX\n");
	        else if(RxSingle == 0x04)
                     printf(" EOT\n");
	        else
                    printf("\n");

/*
	       if (RxSingle == 0x01)
                   printf("posrawd Pos.RxCharIndex=%i char2 %2.2X <%c> SOH\n",Pos.RxCharIndex,RxSingle,RxSingle);
	       else if(RxSingle == 0x02)
                    printf("posrawd Pos.RxCharIndex=%i char2 %2.2X <%c> STX\n",Pos.RxCharIndex,RxSingle,RxSingle);
	       else if(RxSingle == 0x04)
                    printf("posrawd Pos.RxCharIndex=%i char2 %2.2X <%c> EOT\n",Pos.RxCharIndex,RxSingle,RxSingle);
	       else
                    printf("posrawd Pos.RxCharIndex=%i char2 %2.2X <%c>\n",Pos.RxCharIndex,RxSingle,RxSingle);
*/
	     }
	     //sposs[Pos.RxCharIndex]=char2;  // keep all chars 
	     //don't start saving chars until we have a 0x01(SOH) or 0x02(STX)

	     if(Pos.RxCharIndex > 0)
              { 
               RxPoss[Pos.RxCharIndex] = RxSingle; 
               Pos.RxCharIndex++;
              }

	     if((Pos.RxCharIndex == 0) && (RxSingle == 0x01 || RxSingle == 0x02))
               {
                 RxPoss[Pos.RxCharIndex] = RxSingle;
                 Pos.RxCharIndex++;
               }
	
	   } // end of if Pos.ReadChCount == 1 
	} while ((Pos.ReadChCount > 0) && (RxSingle != 0x04) && (Pos.RxCharIndex < 8192)); // 0x04 is the EOT that terminates both packets
	// we do not store the 0D 0A before the SOH of the PS091 or the trailing LF CR NULL of the histogram 

	if(Pos.ReadChCount <= 0) 
            return;   // we ran out of data 

	// we have an EOT, or Pos.RxCharIndex=8192 without an EOT;  process the line 

//	for(i=1; i<=Pos.RxCharIndex; i++) printf("%c ",sposs[i]);
//	printf("\n");

	RxPoss[Pos.RxCharIndex] = 0; // put a null at the end of the line 
        Pos.RecFlag = 1;
//printf("test here \n");
 }
//======================================================================================================================
ExtractPossData()
{
 FILE *fp;
 int i;
 char posfaultcode[5];		// poss fault code string 
 int posfaultnum = 0;		// poss fault integer (hex) number 
 char posfault[512];		// poss fault text string 

//printf("test %s\n", RxPoss);

	// if packet doesn't start with 01(SOH) or 02(STX) and end with 04(EOT),  throw out the line 
	if(((RxPoss[0] != 0x01) && (RxPoss[0] != 0x02)) || RxPoss[Pos.RxCharIndex-1] != 0x04) // bad packet  
          { 
	   Faults[POSMIN] += 1;
           Faults[POSDAY] += 1;
	   printf("%i,poss packet not between 0x01/2 and 0x04, %2.2X %2.2X\n",Faults[POSDAY],RxPoss[0],RxPoss[Pos.RxCharIndex-1]);
	   // write to message file 
	   fp=fopen(mesposlog,"a");
	   fprintf(fp,"%i,%s poss packet not between 0x01/2 and 0x04, %2.2X %2.2X\n",Faults[POSDAY],CurrentTime.CurrDateTime,RxPoss[0],RxPoss[Pos.RxCharIndex-1]);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");
	   fprintf(fp,"%s, PosDayErrors: %i, poss packet not between 0x01/2 and 0x04, %2.2X %2.2X\n",CurrentTime.timeonly,Faults[POSDAY],RxPoss[0],RxPoss[Pos.RxCharIndex-1]);
	   fclose(fp);

	   Pos.RxCharIndex = 0; 
	   return(0);
	}
	// *************** we have a good packet (either PS091 or histogram) *****************
	Pos.minmsgfail = 0;

	// if this a PS091 packet, insert the current computer time 	
	// format SPS091 yymmdd hh:mm 

	if(RxPoss[0] == 0x01)
         {
          CreatePOSTime(&CurrentTime,RxPoss);
	// if this is a PS091 packet, check for non-zero fault code 
 //  if(RxPoss[0] == 0x01)
   //    {
	// watch out, the line might be variable length, fault code may be beyond posn 86 sometimes 
	strncpy(posfaultcode,(RxPoss + 86),4);
	posfaultnum = 0x0000;	 // added this line 01 Aug 07 

	if(strncmp(posfaultcode, "0000",4) != 0)
          {
	   sscanf(posfaultcode,"%X",&posfaultnum);
	   // expect lots of transient noise faults, and some others,
	     // only send email message (Faults[POSMIN]>0) on a few of the critical faults 
	   Faults[POSDAY] += 1;

	   for(i=0;i<=511;i++)
              posfault[i]=0; // clear the string

	   if(posfaultnum & 0x8000) 
               strcat(posfault,",min noise limit");
	   if(posfaultnum & 0x4000) 
                strcat(posfault,",max noise limit");
	   if(posfaultnum & 0x2000) 
               strcat(posfault,",transient noise");
	   if(posfaultnum & 0x1000)
              { 
               strcat(posfault,",constant noise");
               Faults[POSMIN] += 1;
             }
	   if(posfaultnum & 0x0800) 
                strcat(posfault,",false alarm");
	   if(posfaultnum & 0x0400) 
               strcat(posfault,",Gunn current low");
	   if(posfaultnum & 0x0200) 
                strcat(posfault,",not used");
	   if(posfaultnum & 0x0100)
                strcat(posfault,",air temp ");
	   if(posfaultnum & 0x0080)
                 strcat(posfault,",heater voltage");
	   if(posfaultnum & 0x0040) 
                strcat(posfault,",Gunn voltage");
	   if(posfaultnum & 0x0020) 
               { 
                strcat(posfault,",-12V");
                Faults[POSMIN] += 1;
              }
	   if(posfaultnum & 0x0010)  
	    {
		strcat(posfault,",+12V");
		Faults[POSMIN] += 1;
	     }
	   if(posfaultnum & 0x0008) 
		 {
 		  strcat(posfault,",+5V");
		  Faults[POSMIN] += 1; 
		}
	   if(posfaultnum & 0x0004) 
              strcat(posfault,",heater current");
	   if(posfaultnum & 0x0002) 
              strcat(posfault,",not used");
	   if(posfaultnum & 0x0001) 
               strcat(posfault,",DC offset");

	   printf("%i,poss fault code=%s %s\n",Faults[POSDAY],posfaultcode,posfault);
	   fp=fopen(mesposlog,"a");	   // write to message file 
	   fprintf(fp,"%i,%s poss fault code=%s %s\n",Faults[POSDAY],CurrentTime.CurrDateTime,posfaultcode,posfault);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");	   // write to message file 
	   fprintf(fp,"%s,PosDayErrors: %i poss fault code: %s %s\n",CurrentTime.timeonly,Faults[POSDAY],posfaultcode,posfault);
	   fclose(fp);

	}  // end of if posfaultcode != 0 
//------------------------------------------------------------------------------------------------------------------
 //  } // end of if 0x01 

	// if this a PS091 packet, save the current precip rate and accumulation 
	//if(RxPoss[0] == 0x01)
     //   {
	  strncpy(string,RxPoss+75,6);string[6]=0;
	  sscanf(string,"%f",&posrate);
	  printf("string=<%s>\n",string);
	  strncpy(string,RxPoss+69,6);string[6]=0;
	  sscanf(string,"%f",&posaccm);
	  printf("string=<%s>\n",string);
	  printf("posrate=%f posaccm=%f\n",posrate,posaccm);
	  // see if pos accumulation has been reset by power cycle 
	  if(posaccm < posaccmsod) // yes, save new posaccmsod 
            { 
	     printf("%i,%s old posaccmsod= %f new posaccmsod= %f (pwr cycled?)\n",Faults[POSDAY],CurrentTime.CurrDateTime,posaccmsod,posaccm);
	     fp=fopen(mesposlog,"a");	     // write to message file 
	     fprintf(fp,"%i,%s old posaccmsod= %f new posaccmsod= %f (pwr cycled?)\n",Faults[POSDAY],CurrentTime.CurrDateTime,posaccmsod,posaccm);
	     fclose(fp);

	     fp=fopen(MessageFile,"a");	     // write to message file 
	     fprintf(fp,"%s,PosDayErrors: %i, old posaccmsod: %f, new posaccmsod: %f (pwr cycled?)\n",CurrentTime.timeonly,Faults[POSDAY],posaccmsod,posaccm);
	     fclose(fp);

	    posaccmsod=posaccm;
	    fp=fopen(possaccfile,"w"); // overwrite existing value "/home/posacq/posacq/posaccmsod.txt"
	    fprintf(fp,"%f\n",posaccmsod);
	    fclose(fp);
	    } // end of new posaccmsod 
	  // if false alarm fault is set, ignore this rate and correct accumulation in summary file 
	  // note, we do not alter the raw pos file data 
	  if(posfaultnum & 0x0800) 
           {
	     printf("%i,%s false alarm: ignore rate %f and accum %f\n",Faults[POSDAY],CurrentTime.CurrDateTime,posrate,posrate/60.);

	     fp=fopen(mesposlog,"a");	     // write to message file 
	     fprintf(fp,"%i,%s false alarm: ignore rate %f and accum %f\n",Faults[POSDAY],CurrentTime.CurrDateTime,posrate,posrate/60.);
	     fclose(fp);

	     fp=fopen(MessageFile,"a");	     // write to message file 
	     fprintf(fp,"%s,PosDayFaults: %i false alarm: ignore rate %f and accum %f\n",CurrentTime.timeonly,Faults[POSDAY],posrate,posrate/60.);
	     fclose(fp);

	     posaccmsod=posaccmsod+(posrate/60.);

	     fp=fopen(possaccfile,"w"); // overwrite existing value "/home/posacq/posacq/posaccmsod.txt"
	     fprintf(fp,"%f\n",posaccmsod);
	     fclose(fp);
	     posrate=0.0;
	  } // end of if 0x0800 
	  // make pos accumulation for the day for summary file 
	  posaccmtdy = posaccm - posaccmsod;
	}
	// print packet if posd=1 (a kybd command) 
	if(Pos.dumpline) //=1
	 printf("POS %i\n%s\n",Pos.RxCharIndex,RxPoss);
//	 printf("%s\n",RxPoss);

	// write packet to file 
	fp=fopen(poslog,"a");
	fprintf(fp,"%s",RxPoss);
	fclose(fp);

	Pos.RxCharIndex = 0;	// reset the char counter 
} // end of checkposs() 
/************************************************/
GetParsivelSerialData()
{
char RxIn;//char1;
	// this is for Steve Brady's set of output data, rather than the factory default set 
	// data is 9600, 8,N,1, typically 1 minute, but 30 sec for factory default
	/*   sb set: 101+4095=4196 char +crlf
	   WKR,dd.mm.yyyy,hh:mm:ss,0,000,0000.000,0000.00,00,00,+RASN,RLS+,00.000,0000,00000,00000,000,0.00,00.0
	    1	22   ccc       	station name
	    2	21   dd.mm.yyyy sensor date
	    3	20   hh:mm:ss   sensor time
	    4	18   0       	sensor status
	    5	25   000     	error code
	    6	01   0000.000	rain intensity mm/h
	    7	02   0000.00	rain accumulation mm
	    8	03   00		weather code SYNOP wawa
	    9	04   00		weather code SYNOP ww
	   10	05   +RASN	weather code METAR/SPECI 
	   11	06   RLS+	weather code NWS
	   12	07   00.000	radar reflectivity dBz
	   13	08   0000	MOR visibility m
	   14	11   00000	number of detected particles
	   15	10   00000	signal amplitude of laser strip
	   16	12   000	temp of sensor deg C
	   17	16   0.00	current through heater amps
	   18	17   00.0	power supply voltage in sensor volts
	   19   93   000x	32x32=1024 x 4 char(000 ) -trailing space =4095 chars
*/
	// the CS/Z/1 command in resetpar() takes about 7 seconds to execute, then the 60 sec
	//   output messages start at about nn08. This parsivel loses about 10 seconds per day, so
	//   by the end of the day the messages come out at about nn18. 
	   
	// read 1 char at a time until we have a line (ends in CR 0x0D LF 0x0A), or no more char 

	do {
   	   Parsivel.ReadChCount = read(Parsivel.ComPort,&RxIn,1);
	   if(Parsivel.ReadChCount < 0)
                perror("read failed");
           if(Parsivel.ReadChCount == 1) 
             {
//                if(char1==0x0D||char1==0x0A) printf("char1=%2.2X %c\n",char1,char1);
		if((RxIn != 0x0D) && (RxIn != 0x0A))
                 { // don't keep cr and lf
		  RxParsivel[Parsivel.RxCharIndex] = RxIn; 
		  Parsivel.RxCharIndex++;
                 }
              }
	}while ((Parsivel.ReadChCount > 0) && (RxIn != 0x0A) && (Parsivel.RxCharIndex < 4400));

	if(Parsivel.ReadChCount <= 0) 
            return;   // we ran out of data 
	// we have a LF, or pchar1=4400 without a LF;  process the line 

	RxParsivel[Parsivel.RxCharIndex++]=0;	// put a null at the end of the line 
        Parsivel.RecFlag = 1;
}
//===============================================================================
ExtractParsivelData()
{
FILE *fp;
int i;
char sparsivelarc[256]={0};	// one line of data to archive to disk 
char sparsivelraw[4200]={0};	// raw data to archive to disk 

	if(Parsivel.RxCharIndex != 4199) // bad line
         {  
	   Faults[PARMIN] += 1;
           Faults[PARDAY] += 1;
	   printf("%i,parsivel line not 4197 chars, pchar1=%i <%s>\n",Faults[PARDAY],Parsivel.RxCharIndex,RxParsivel);
	   fp=fopen(mesparlog,"a");	   // write to message file 
	   fprintf(fp,"%i,%s parsivel line not*********************************************** 4199 chars, pchar1=%i <%s>\n",Faults[PARDAY],CurrentTime.CurrDateTime,Parsivel.RxCharIndex,RxParsivel);
	   fclose(fp);

           Parsivel.RxCharIndex = 0;

	   fp=fopen(MessageFile,"a");	   // write to message file 
//	   fprintf(fp,"%s,ParDayFaults:%i,%s parsivel line not*********************************************** 4199 chars, pchar1=%i <%s>\n",CurrentTime.CurrDateTime,Faults[PARDAY],Parsivel.RxCharIndex,RxParsivel);
fprintf(fp,"%s,ParDayFaults:%i, parsivel line not*********************************************** 4199 chars, pchar1=%i <%s>\n",CurrentTime.timeonly,Faults[PARDAY],Parsivel.RxCharIndex,RxParsivel);
	   fclose(fp);
 
	   return(0);
	}
// *************** we have a good line ************************
	Parsivel.minmsgfail = 0;//minnopar=0;

	//printf("%i\n",pchar1);
	// make up the archive line 
	for(i=0;i<256;i++)// clear the string(why have to do this?)
             sparsivelarc[i] = 0;	 
	// add the current computer time 	
	strcpy(sparsivelarc,CurrentTime.CurrDateTime);	// current time 
	strncat(sparsivelarc,RxParsivel,101);	// the rest of the regular data

	// find the sensor status field 
	if(RxParsivel[24] != 0x30)// bad sensor status
         {  
	   Faults[PARMIN] += 1;
           Faults[PARDAY] +=1;
	   printf("%i,bad sensor status <%c>\n",Faults[PARDAY],RxParsivel[24]);
	   // write to message file 
	   fp=fopen(mesparlog,"a");
	   fprintf(fp,"%i,%s bad sensor status <%c>\n",Faults[PARDAY],CurrentTime.CurrDateTime,RxParsivel[24]);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");
	   fprintf(fp,"%s,ParDayFaults: %i,bad sensor status <%c>\n",CurrentTime.timeonly,Faults[PARDAY],RxParsivel[24]);
	   fclose(fp);

	 } 

	// save the current precip rate and accumulation 
	strncpy(string,RxParsivel+30,8);string[8]=0;
	printf("string=<%s>\n",string);
	sscanf(string,"%f",&parrate);
	strncpy(string,RxParsivel+39,7);string[7]=0;
	printf("string=<%s>\n",string);
	sscanf(string,"%f",&paraccm);
	printf("parrate=%f paraccm=%f\n",parrate,paraccm);

	// print each line if pard=1 (a kybd command) 
	if(Parsivel.dumpline) //=1
         {
	  printf("PAR %.109s\n",RxParsivel);	// only print first 101 char, plus 2 values of raw data 
	  printf("PAR %s\n",sparsivelarc);
	}

	// write archive line to file 
	fp=fopen(parlog,"a");
	fprintf(fp,"%s\n",sparsivelarc);
	fclose(fp);

	// write the raw data to a separate file 

	// make up the archive line 
	for(i=0;i<4200;i++)
           sparsivelraw[i]=0;	// clear the string(why have to do this?) 
	// add the current computer time 	
	strcpy(sparsivelraw,CurrentTime.CurrDateTime);	// current time 
	strncat(sparsivelraw,RxParsivel+102,4095);	// the raw data
	// write archive line to file 
	fp=fopen(parrawlog,"a");
	fprintf(fp,"%s\n",sparsivelraw);
	fclose(fp);


	Parsivel.RxCharIndex = 0;	// reset the char counter 
} // end of checkparsivelsb() 
//=============================================================
GetVisSerialData()
{
char RxGet;

	/* data is 9600, 7,e,1, typically 1 minute
	   message type 2 is 56 char total in PWD22

	   SOH 0x01
	   PW  sensor identifier
	   b   space
	   ss  2 char id, space 1 if not defined
	   STX 0x02
	   c	vis alarm 1 and 2
	   c	hardware error 1 and 2
	   bnnnnn 6 digit 1 min vis max 50000m
	   bnnnnn 6 digit 10 min vis max 50000m
	   bsss      instant present wx NWS code
	   bnn    3 digit instant present wx code 0...99
	   bnn    3 digit 15 min present wx code 0...99
	   bnn    3 digit 1 hour present wx code 0...99
	   bxxx.xx  7 digit precip rate mm/hr
	   bxxx.xx  7 digit accum water 0...999mm
	   bnnnn    5 digit accum snow 0...999mm
	   ETX 0x03
	   CR  0x0D
	   LF  0x0A
	*/
	// note some of the status message responses end with a bell (0x07), ignore them 

	/* note the AMES command sets the automatic interval to 60 seconds, but I haven't
	   found how to sync that 60 second interval to the FD12P (or PC) clock minute change.
	   Issuing the AMES command on the minute change doesn't seem to do it.
	   Issuing the AMES command seems to retard the message by about 10 seconds (but
	   sometimes about 20 seconds) from the pre-existing time.
	   Maybe we will have to issue multiple AMES commands until the output messages
	   fall within a 10 second window after the minute change.
	   Surely there must be a better way to sync to the minute change. */


	   
	// read 1 char at a time until we have a line (ends in CR 0x0D LF 0x0A), or no more char 
	do {
   	   PWD.ReadChCount=read(PWD.ComPort,&RxGet,1);
	   if(PWD.ReadChCount < 0)
                perror("read failed");
           if(PWD.ReadChCount == 1) 
            {
//                if(char3==0x0D||char3==0x0A) printf("char3=%2.2X %c\n",char3,char3);
		if(RxGet!=0x0D && RxGet!=0x0A && RxGet!=0x07)// don't keep cr or lf or bell
                 { 
		  RxVis[PWD.RxCharIndex] = RxGet; 
		  PWD.RxCharIndex++;
                 }
           }
	} while ((PWD.ReadChCount > 0) && (RxGet != 0x0A) && (PWD.RxCharIndex < 255));

	if(PWD.ReadChCount <= 0) 
           return;   // we ran out of data 

	// we have a LF, or pchar3=255 without a LF;  process the line 

//	for(i=1; i<=pchar3; i++) printf("%c ",svis[i]);
//	printf("\n");

	RxVis[PWD.RxCharIndex++]=0;	// put a null at the end of the line 
	// if pchar3 != 56-2+1  throw out the line
       PWD.RecFlag = 1;
 }
//===============================================================================================
ExtractVis()
{ 
FILE *fp;
char svisarc[256]={0};		// one line of data to archive to disk 
int i;
	if(PWD.RxCharIndex != 55) // bad line 
          { 
          Faults[VISDAY] += 1;
          Faults[VISMIN] += 1;

	   printf("%i,vis line not 55 chars, pchar3=%i <%s>\n",Faults[VISDAY],PWD.RxCharIndex,RxVis);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s vis line not 55 chars, pchar3=%i <%s>\n",Faults[VISDAY],CurrentTime.CurrDateTime,PWD.RxCharIndex,RxVis);
	   fclose(fp);
	   PWD.RxCharIndex = 0; 

	   fp=fopen(MessageFile,"a");
	   fprintf(fp,"%s,VISDayFaults: %i, vis line not 55 chars, pchar3=%i <%s>\n",CurrentTime.timeonly,Faults[VISDAY],PWD.RxCharIndex,RxVis);
	   fclose(fp);
	   return(0);
	}

	// *************** we have a good line ************************

	PWD.minmsgfail = 0;
	//printf("%i\n",pchar3);
	// make up the archive line 
	for(i=0;i<256;i++)
           svisarc[i]=0;	// clear the string(why have to do this?) 
	// add the current computer time 	

	strcpy(svisarc,CurrentTime.CurrDateTime);	// current time 
	strncat(svisarc,(RxVis+1),52);	// the rest, don't save control characters 
	// make it comma separated fields 
	svisarc[25]=',';
	svisarc[28]=',';
	svisarc[34]=',';
	svisarc[40]=',';
	svisarc[44]=',';
	svisarc[47]=',';
	svisarc[50]=',';
	svisarc[53]=',';
	svisarc[60]=',';
	svisarc[67]=',';

	// if the sensor can't calculate a valid number, it puts ///// in the field 
	// we want to change / to -99 
	if(svisarc[33]== 0x2F) strncpy(svisarc+29,"  -99", 5);	
	if(svisarc[39]== 0x2F) strncpy(svisarc+35,"  -99", 5);	
	if(svisarc[43]== 0x2F) strncpy(svisarc+41,"-99",   3);	
	if(svisarc[46]== 0x2F) strncpy(svisarc+45,"-9",    2);	
	if(svisarc[49]== 0x2F) strncpy(svisarc+48,"-9",    2);	
	if(svisarc[52]== 0x2F) strncpy(svisarc+51,"-9",    2);	
	if(svisarc[59]== 0x2F) strncpy(svisarc+54,"-99.00",6);	
	if(svisarc[66]== 0x2F) strncpy(svisarc+61,"-99.00",6);	
	if(svisarc[71]== 0x2F) strncpy(svisarc+68," -99",  4);	

	// find the sensor status fields 
	if((RxVis[7] != 0x30) || (RxVis[8] != 0x30))// bad sensor status
          {  
	   Faults[VISMIN] += 1;
           Faults[VISDAY] += 1;
	   printf("%i,bad sensor status <%c%c>\n",Faults[VISDAY],RxVis[7],RxVis[8]);
	   // write to message file 
	   fp=fopen(mesvislog,"a");
	   fprintf(fp,"%i,%s bad sensor status <%c%c>\n",Faults[VISDAY],CurrentTime.CurrDateTime,RxVis[7],RxVis[8]);
	   fclose(fp);

	   fp=fopen(MessageFile,"a");
	   fprintf(fp,"%s,VisDayFaults: %i,bad sensor status <%c%c>\n",Faults[VISDAY],CurrentTime.timeonly,RxVis[7],RxVis[8]);
	   fclose(fp);

	 } 

	// save the current precip rate and accumulation 
	// choice of water or snow accum, choose water for now 
	strncpy(string,svisarc+54,6);string[6]=0;
	//printf("string=<%s>\n",string);
	sscanf(string,"%f",&visrate);
	strncpy(string,svisarc+61,6);string[6]=0;
	//printf("string=<%s>\n",string);
	sscanf(string,"%f",&visaccm);
	printf("visrate=%f visaccm=%f\n",visrate,visaccm);

	// print each line if visd=1 (a kybd command) 
	if(PWD.dumpline)  //=1
      {
	 printf("VIS %s\n",RxVis);
	 printf("VIS %s\n",svisarc);
	}

	// write archive line to file 
	fp=fopen(vislog,"a");
	fprintf(fp,"%s\n",svisarc);
	fclose(fp);

	PWD.RxCharIndex = 0;	// reset the char counter 
} // end of checkvis() 
//===================================================================================

//=======================================================================
  myatoi(char *strptr,unsigned long *out)
   {  
    unsigned long ret_value = 0;
    char vari;
                           
    while(*strptr < '0' || *strptr > '9')    
     ++strptr;

    while(*strptr)
    {
      vari = *strptr; 

      if( vari >= '0'&& vari <= '9')
        { 
          vari-='0';
          ret_value = 10*ret_value + vari;
          ++strptr;
         }  
        else 
         *out = ret_value;
      } 
         *out = ret_value;
   }                                                      
//=================================================================================
VisTime(LocalTime *sptr,char *inout)
{
// format SPS091 yymmdd hh:mm 
  unsigned char *ptr;
  unsigned char ii;
  // /Cyymmddhhmmss\r
  ptr = sptr->auxtimeptr; // hh:mm:ss,mm/dd/yy
  
*inout++ =  '/';
*inout++ =  'C';

while(*ptr != ',')
 ptr++;

ptr += 7;
*inout++ =  *ptr++;
*inout++ =  *ptr;
ptr -= 7;
*inout++ =  *ptr++;
*inout++ =  *ptr++;
*ptr++;


*inout++ =  *ptr++;
*inout++ =  *ptr;
ptr -= 13;
*inout++ =  *ptr++;
*inout++ =  *ptr++;
*ptr++;
*inout++ =  *ptr++;
*inout++ =  *ptr++;
*ptr++;
*inout++ =  *ptr++;
*inout++ =  *ptr;

*inout++ =  '\r';
}
//-------------------------------------------------------------------------------
checkmicro()
{
 FILE *fp; 
 char char0;
	 //data is 9600 8N1 ending in CRLF  "ROOM: xx.xC, xx.xrhCRLF"
	// read 1 char at a time until we have a line (ends in CR 0x0D LF 0x0A), or no more char

	do {
   	   AuxDevice.ReadChCount = read(AuxDevice.ComPort,&char0,1);

	   if(AuxDevice.ReadChCount < 0) 
              perror("read failed"); 

           if(AuxDevice.ReadChCount == 1)
             {
//                if(char0==0x0D||char0==0x0A) printf("char0=%2.2X %c\n",char0,char0);
		if((char0!=0x0D) && (char0!=0x0A)) // don't keep cr and lf
                  {
		  RxAux[AuxDevice.RxCharIndex]=char0; 
		  AuxDevice.RxCharIndex++;
                  }
            }
	}while ((AuxDevice.ReadChCount > 0) && (char0 != 0x0A) && (AuxDevice.RxCharIndex<255));

	if(AuxDevice.ReadChCount <= 0) 
                return;   // we ran out of data 

	// we have a LF, or pchar0=255 without a LF;  process the line


	RxAux[AuxDevice.RxCharIndex]=0;	// put a null at the end of the line 

	// if pchar0 < 19 throw out the line 
	if(AuxDevice.RxCharIndex<10)
         { // bad line 
	  Faults[AUXMIN] += 1;
	  Faults[AUXDAY] += 1;

	   printf("Aux Daily Faults: %i,micro line not 10 chars, pchar0=%i <%s>\n",Faults[AUXDAY],AuxDevice.RxCharIndex,RxAux);
	   // write to message file 
	   fp=fopen(MessageFile,"a");
	   fprintf(fp,"%s,Aux Daily Faults: %i micro line not 10 chars, pchar0=%i <%s>\n",CurrentTime.timeonly,Faults[AUXDAY],AuxDevice.RxCharIndex,RxAux);
	   fclose(fp);
	   AuxDevice.RxCharIndex = 0; 
	   return(0);
	}

	AuxDevice.minmsgfail = 0;
	//printf("%i\n",pchar3);
	// make up the archive line 
  AuxDevice.RecFlag = 1;
}// end of checkmicro() 
//------------------------------------------------------------------------------------------
ExtractAuxDevice()
{
 FILE *fp;
 char temp[5],hums[5],i;
 float ambtemp,hum;

  ParseMicro(RxAux,temp,hums);
 
    sscanf(temp, "%f", &ambtemp);
    sscanf(hums, "%f", &hum);
    printf("RMT=%s\n",RxAux);

    if(ambtemp > 36.0)	
       {
	  Faults[AUXMIN] += 1;
	  Faults[AUXDAY] += 1;
	  printf("Ambient Temperature High!!\n");
	  fp=fopen(MessageFile,"a");
	  fprintf(fp,"%s,Aux Daily Faults: %i, Ambient Temp. High %.1f C\n",CurrentTime.timeonly,Faults[AUXDAY],ambtemp);
	  fclose(fp);
       }

   AuxDevice.RxCharIndex = 0; 
   for(i=0;i<25;i++)
       RxAux[i]=0;	

} // end of checkmicro() 
//=======================================================
ParseMicro(char *ptr,char *in_1,char *in_2)
{
 while(*ptr != 'C')
  {
   *in_1++ = *ptr;
    ptr++;
   }
*in_1 = 0;

ptr++;
ptr++;

 while(*ptr != 'r')
 {
  *in_2++ = *ptr;
    ptr++;
 }  
*in_2 = 0;
}
//========================================
CreatePaths()
{

 strcpy(parpath,mainpath);
 strcat(parpath, "data/");

 strcpy(possaccfile,mainpath);
 strcat(possaccfile, "posaccmsod.txt");

 strcpy(TempMailFile,mainpath);
 strcat(TempMailFile, "lastmailmes");

 //strcpy(InParFileName,mainpath);
 //strcat(InParFileName, "POSACQ1.PAR");
}
